(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     28257,        721]
NotebookOptionsPosition[     27180,        681]
NotebookOutlinePosition[     27543,        697]
CellTagsIndexPosition[     27500,        694]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"T_", 
     RowBox[{"{", 
      RowBox[{"p", "^", "r"}], "}"}], " ", "is", " ", "a", " ", "polynomial", 
     " ", "in", " ", "T_p", " ", "so", " ", "takes", " ", "r"}], ",", "p", 
    ",", 
    RowBox[{
    "k", " ", "and", " ", "writes", " ", "that", " ", "polynomial", " ", 
     "with", " ", "x", " ", "as", " ", "the", " ", "variable", " ", "for", 
     " ", "T_p"}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"HeckePolynomial", "[", 
     RowBox[{"r_", ",", "p_", ",", "k_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"return", "=", 
        RowBox[{"-", "1"}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"r", "<=", "0"}], ",", 
         RowBox[{"return", "=", "1"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"r", "\[Equal]", "1"}], ",", 
         RowBox[{"return", "=", "x"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"r", ">", "1"}], ",", 
         RowBox[{"return", " ", "=", 
          RowBox[{
           RowBox[{
            RowBox[{"HeckePolynomial", "[", 
             RowBox[{
              RowBox[{"r", "-", "1"}], ",", "p", ",", "k"}], "]"}], "*", 
            "x"}], "-", 
           RowBox[{
            RowBox[{"p", "^", 
             RowBox[{"(", 
              RowBox[{"k", "-", "1"}], ")"}]}], "*", 
            RowBox[{"HeckePolynomial", "[", 
             RowBox[{
              RowBox[{"r", "-", "2"}], ",", "p", ",", "k"}], "]"}]}]}]}]}], 
        "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"FullSimplify", "[", "return", "]"}]}]}], 
     "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"Have", " ", "the", " ", "traces", " ", "for", " ", "T_", 
      RowBox[{"{", 
       RowBox[{"p", "^", "r"}], "}"}], " ", "for", " ", "r"}], "=", 
     RowBox[{
      RowBox[{"1", " ", "to", " ", "d"}], "-", 
      RowBox[{
      "1", " ", "where", " ", "d", " ", "is", " ", "the", " ", "dimension", 
       " ", "of", " ", "S_k", 
       RowBox[{
        RowBox[{"(", "1", ")"}], ".", " ", "This"}], " ", "is", " ", "enough",
        " ", "information", " ", "to", " ", "get", " ", "the", " ", 
       "characteristic", " ", "polynomial", " ", "of", " ", "T_p"}]}]}], " ", 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CharPolyHelper", "[", 
      RowBox[{"p_", ",", "traces_", ",", "k_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"traces2", ",", "r", ",", "d", ",", "toReplace"}], "}"}], ",",
        "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"traces2", "=", 
         RowBox[{"traces", "*", "0"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"d", "=", 
         RowBox[{
          RowBox[{"Length", "[", "traces", "]"}], "+", "1"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"r", "=", "1"}], ",", 
          RowBox[{"r", "<", "d"}], ",", 
          RowBox[{"r", "++"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"toReplace", "=", 
            RowBox[{
             RowBox[{
              RowBox[{"traces", "[", 
               RowBox[{"[", "r", "]"}], "]"}], "-", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"HeckePolynomial", "[", 
                 RowBox[{"r", ",", "p", ",", "k"}], "]"}], "-", 
                RowBox[{"x", "^", "r"}]}], ")"}]}], "/.", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"x", "\[Rule]", 
                RowBox[{"traces2", "[", 
                 RowBox[{"[", "1", "]"}], "]"}]}], ",", 
               RowBox[{
                RowBox[{"x", "^", "i_"}], "\[Rule]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"i", "\[GreaterEqual]", "1"}], "&&", 
                   RowBox[{"i", "<", "r"}]}], ",", 
                  RowBox[{"traces2", "[", 
                   RowBox[{"[", "i", "]"}], "]"}], ",", "0"}], "]"}]}]}], 
              "}"}]}]}], ";", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"traces2", "[", 
             RowBox[{"[", "r", "]"}], "]"}], "=", "toReplace"}], ";"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "traces2"}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"CharPolyHelper2", "[", "powerTraces_", "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"matrixToMake", ",", "k", ",", "i", ",", "j"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"k", "=", 
        RowBox[{"Length", "[", "powerTraces", "]"}]}], ";"}]}], 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
       "Complete", " ", "exponential", " ", "Bell", " ", "polynomials", " ", 
        "to", " ", "express", " ", "c_k", " ", "in", " ", "terms", " ", "of", 
        " ", "s_k"}], "=", 
       RowBox[{"Tr", 
        RowBox[{"(", 
         RowBox[{"A", "^", "k"}], ")"}]}]}], "*)"}], "\[IndentingNewLine]", 
     "]"}]}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "Tn", " ", "will", " ", "be", " ", "written", " ", "as", " ", "a", " ", 
     "polynomial", " ", "in", " ", "all", " ", "the", " ", "variables", " ", 
     "Tp", " ", "for", " ", "p", " ", "dividing", " ", "n"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"FactorHeckeOperator", "[", 
     RowBox[{"n_", ",", "k_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"factors", ",", "length", ",", 
        RowBox[{"return", "=", "1"}], ",", "p", ",", "r", ",", "contrib"}], 
       "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"factors", "=", 
        RowBox[{"FactorInteger", "[", "n", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"length", "=", 
        RowBox[{"Length", "[", "factors", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", "=", "1"}], ",", 
         RowBox[{"i", "\[LessEqual]", "length"}], ",", 
         RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"p", ",", "r"}], "}"}], "=", 
           RowBox[{"factors", "[", 
            RowBox[{"[", "i", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"contrib", "=", 
           RowBox[{"HeckePolynomial", "[", 
            RowBox[{"r", ",", "p", ",", "k"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"contrib", "=", 
           RowBox[{"contrib", "/.", 
            RowBox[{"{", 
             RowBox[{"x", "\[Rule]", 
              RowBox[{"T", "[", "p", "]"}]}], "}"}]}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"return", "=", 
           RowBox[{"return", "*", "contrib"}]}], ";"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       "return"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "Take", " ", "a", " ", "power", " ", "series", " ", "given", " ", "as", 
     " ", "a", " ", "finite", " ", "list", " ", "up", " ", "to", " ", "some", 
     " ", "order", " ", "and", " ", "apply", " ", "the", " ", "Hecke", " ", 
     "operator", " ", "Tp", " ", "as", " ", "a", " ", "new", " ", "list", " ",
      "with", " ", "Nulls", " ", "for", " ", "coefficients", " ", "that", " ", 
     RowBox[{"can", "'"}], "t", " ", "be", " ", "determined", " ", "without", 
     " ", "higher", " ", "order", " ", "data"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ApplyTp", "[", 
      RowBox[{"f_", ",", "p_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"length", ",", 
         RowBox[{"i", "=", "0"}], ",", 
         RowBox[{"g", "=", 
          RowBox[{"f", "*", "0"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"length", "=", 
         RowBox[{"Length", "[", "f", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"i", "=", "1"}], ",", 
          RowBox[{"i", "\[LessEqual]", "length"}], ",", 
          RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"p", "*", "i"}], "-", "p", "+", "1"}], "\[LessEqual]", 
              "length"}], ",", 
             RowBox[{
              RowBox[{"g", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "=", 
              RowBox[{
               RowBox[{"g", "[", 
                RowBox[{"[", "i", "]"}], "]"}], "+", 
               RowBox[{"f", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"p", "*", "i"}], "-", "p", "+", "1"}], "]"}], 
                "]"}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"p", "*", "i"}], "-", "p", "+", "1"}], ">", "length"}],
              ",", 
             RowBox[{
              RowBox[{"g", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "=", "Null"}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Mod", "[", 
               RowBox[{"i", ",", "p"}], "]"}], "\[Equal]", "1"}], ",", 
             RowBox[{
              RowBox[{"g", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "=", 
              RowBox[{
               RowBox[{"g", "[", 
                RowBox[{"[", "i", "]"}], "]"}], "+", 
               RowBox[{"f", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"i", "-", "1"}], ")"}], "/", "p"}], "+", "1"}], 
                 "]"}], "]"}]}]}]}], "]"}], ";"}]}], "\[IndentingNewLine]", 
         "]"}], ";", "\[IndentingNewLine]", "g"}]}], "\[IndentingNewLine]", 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"Apply", " ", "Tp", " ", "m", " ", "times"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ApplyTpIterated", "[", 
      RowBox[{"f_", ",", "m_", ",", "p_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"count", "=", "0"}], ",", "return"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"m", "<=", "0"}], ",", 
          RowBox[{"return", "=", "f"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"m", "\[Equal]", "1"}], ",", 
          RowBox[{"return", "=", 
           RowBox[{"ApplyTp", "[", 
            RowBox[{"f", ",", "p"}], "]"}]}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"m", ">", "1"}], ",", 
          RowBox[{"return", "=", 
           RowBox[{"ApplyTp", "[", 
            RowBox[{
             RowBox[{"ApplyTpIterated", "[", 
              RowBox[{"f", ",", 
               RowBox[{"m", "-", "1"}], ",", "p"}], "]"}], ",", "p"}], 
            "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", "return"}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "Apply", " ", "a", " ", "general", " ", "Tn", " ", "by", " ", "factoring",
      " ", "n", " ", "and", " ", "then", " ", "applying", " ", "the", " ", 
     "requisite", " ", 
     RowBox[{"p", "^", "r"}], " ", "pieces"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ApplyTn", "[", 
     RowBox[{"n_", ",", "k_", ",", "f_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"factors", ",", "length", ",", 
        RowBox[{"g", "=", "f"}], ",", "p", ",", "r", ",", "contrib"}], "}"}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"factors", "=", 
        RowBox[{"FactorInteger", "[", "n", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"length", "=", 
        RowBox[{"Length", "[", "factors", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", "=", "1"}], ",", 
         RowBox[{"i", "\[LessEqual]", "length"}], ",", 
         RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"p", ",", "r"}], "}"}], "=", 
           RowBox[{"factors", "[", 
            RowBox[{"[", "i", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"contrib", "=", 
           RowBox[{"HeckePolynomial", "[", 
            RowBox[{"r", ",", "p", ",", "k"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"g", "=", 
           RowBox[{"contrib", "/.", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"Power", "[", 
                RowBox[{"x", ",", "o_"}], "]"}], "\[Rule]", 
               RowBox[{"ApplyTpIterated", "[", 
                RowBox[{"g", ",", "o", ",", "p"}], "]"}]}], ",", 
              RowBox[{"x", "\[Rule]", 
               RowBox[{"ApplyTp", "[", 
                RowBox[{"g", ",", "p"}], "]"}]}]}], "}"}]}]}], ";"}]}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"This", " ", "turns", " ", "T_", 
          RowBox[{"{", 
           RowBox[{"p", "^", "r"}], "}"}], " ", "to", " ", "a", " ", 
          "polynomial", " ", "then", " ", "applies", " ", "that", " ", 
          "polynomial", " ", "to", " ", "the", " ", "current", " ", "power", 
          " ", "series", " ", "so", " ", "far", " ", "g"}], "*)"}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", "g"}]}], 
     "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "Takes", " ", "a", " ", "function", " ", "of", " ", "x", " ", "and", " ", 
     "produces", " ", "a", " ", "truncated", " ", "power", " ", "series", " ",
      "of", " ", "it", " ", "given", " ", "as", " ", "a", " ", "list", " ", 
     "up", " ", "to", " ", "order", " ", 
     RowBox[{"x", "^", "n"}], "\[IndentingNewLine]", "  ", "This", " ", "is", 
     " ", "ready", " ", "for", " ", "input", " ", "into", " ", "applying", 
     " ", "Tn"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"FunctionPowerSeries", "[", 
     RowBox[{"f_", ",", "n_"}], "]"}], ":=", 
    RowBox[{"CoefficientList", "[", 
     RowBox[{
      RowBox[{"Series", "[", 
       RowBox[{"f", ",", 
        RowBox[{"{", 
         RowBox[{"x", ",", "0", ",", "n"}], "}"}]}], "]"}], ",", "x"}], 
     "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.721957814737502*^9, 3.721958009694977*^9}, {
   3.721958050839901*^9, 3.7219581430522146`*^9}, {3.721958392613966*^9, 
   3.721958481486306*^9}, {3.7219585636243954`*^9, 3.721958572478035*^9}, {
   3.721958606331893*^9, 3.7219586211392064`*^9}, {3.721958680372386*^9, 
   3.7219588621505613`*^9}, {3.721959018364034*^9, 3.721959049040406*^9}, {
   3.721963304868786*^9, 3.7219633646535263`*^9}, {3.721963400421106*^9, 
   3.721963673121126*^9}, {3.7219637157647743`*^9, 3.7219637250461583`*^9}, {
   3.7219637635779247`*^9, 3.7219637748437357`*^9}, {3.721963832360156*^9, 
   3.7219638370946007`*^9}, {3.7219638684568553`*^9, 
   3.7219638975041423`*^9}, {3.721963939598488*^9, 3.721964021727069*^9}, {
   3.7219640633886633`*^9, 3.7219641042642436`*^9}, {3.7219642985507245`*^9, 
   3.72196430137889*^9}, {3.721964385692585*^9, 3.721964427086159*^9}, {
   3.7219644655710516`*^9, 3.721964555051181*^9}, {3.7219645954422703`*^9, 
   3.721964715961999*^9}, {3.721964883964401*^9, 3.721964884261279*^9}, {
   3.721964928264245*^9, 3.7219649321705503`*^9}, {3.7219652914979925`*^9, 
   3.7219652990605993`*^9}, {3.721965372343005*^9, 3.7219655404473305`*^9}, {
   3.721965749781011*^9, 3.7219659415828915`*^9}, {3.7219663408428316`*^9, 
   3.721966393002187*^9}, {3.7219664619875183`*^9, 3.7219665372386403`*^9}, {
   3.7371666629368935`*^9, 3.7371668670073166`*^9}, {3.7371669124334145`*^9, 
   3.737166961454636*^9}, {3.737167087903846*^9, 3.7371670939499454`*^9}, {
   3.737167123959177*^9, 3.7371671602570515`*^9}, {3.737167213349248*^9, 
   3.7371672529114285`*^9}, {3.737167292110428*^9, 3.7371672930361824`*^9}, {
   3.7371673534704456`*^9, 3.7371673807595553`*^9}, {3.73716744268738*^9, 
   3.737167443436921*^9}, {3.737167516196718*^9, 3.737167636761675*^9}, {
   3.737167758698884*^9, 3.737167848452106*^9}, {3.737168043686857*^9, 
   3.737168055944374*^9}, {3.737168104675022*^9, 3.737168141816386*^9}, {
   3.7371683489600697`*^9, 3.7371685345811586`*^9}, {3.7371685650406685`*^9, 
   3.737168635974925*^9}, 3.737168752311929*^9, {3.737169047612236*^9, 
   3.7371690792265587`*^9}, {3.73716912511873*^9, 3.737169136345723*^9}, {
   3.7371692481101904`*^9, 3.737169289409522*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"HeckePolynomial", "[", 
  RowBox[{"3", ",", "p", ",", "k"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"HeckePolynomial", "[", 
  RowBox[{"4", ",", "p", ",", "k"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"HeckePolynomial", "[", 
  RowBox[{"5", ",", "p", ",", "k"}], "]"}]}], "Input",
 CellChangeTimes->{{3.721958018659314*^9, 3.7219580342030663`*^9}, {
  3.721958100677883*^9, 3.721958128763321*^9}, {3.721958196758198*^9, 
  3.7219582419673815`*^9}, {3.7219583250735493`*^9, 3.721958330254731*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "2"}], " ", 
   SuperscriptBox["p", 
    RowBox[{
     RowBox[{"-", "1"}], "+", "k"}]], " ", "x"}], "+", 
  SuperscriptBox["x", "3"]}]], "Output",
 CellChangeTimes->{{3.7219580292433615`*^9, 3.721958146285536*^9}, {
   3.721958198608922*^9, 3.7219582439564323`*^9}, 3.7219583308601646`*^9, 
   3.7219660127893963`*^9, 3.7219661648540525`*^9}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["p", 
   RowBox[{
    RowBox[{"-", "2"}], "+", 
    RowBox[{"2", " ", "k"}]}]], "-", 
  RowBox[{"3", " ", 
   SuperscriptBox["p", 
    RowBox[{
     RowBox[{"-", "1"}], "+", "k"}]], " ", 
   SuperscriptBox["x", "2"]}], "+", 
  SuperscriptBox["x", "4"]}]], "Output",
 CellChangeTimes->{{3.7219580292433615`*^9, 3.721958146285536*^9}, {
   3.721958198608922*^9, 3.7219582439564323`*^9}, 3.7219583308601646`*^9, 
   3.7219660127893963`*^9, 3.7219661649790525`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"3", " ", 
   SuperscriptBox["p", 
    RowBox[{
     RowBox[{"-", "2"}], "+", 
     RowBox[{"2", " ", "k"}]}]], " ", "x"}], "-", 
  RowBox[{"4", " ", 
   SuperscriptBox["p", 
    RowBox[{
     RowBox[{"-", "1"}], "+", "k"}]], " ", 
   SuperscriptBox["x", "3"]}], "+", 
  SuperscriptBox["x", "5"]}]], "Output",
 CellChangeTimes->{{3.7219580292433615`*^9, 3.721958146285536*^9}, {
   3.721958198608922*^9, 3.7219582439564323`*^9}, 3.7219583308601646`*^9, 
   3.7219660127893963`*^9, 3.7219661651353045`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"HeckePolynomial", "[", 
  RowBox[{"3", ",", "p", ",", "k"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"CharPolyHelper", "[", 
  RowBox[{"p", ",", 
   RowBox[{"{", 
    RowBox[{"d", ",", "e", ",", "f"}], "}"}], ",", "k"}], "]"}]}], "Input",
 CellChangeTimes->{{3.737167321636009*^9, 3.7371673390000963`*^9}, {
  3.7371673946835947`*^9, 3.7371674993902683`*^9}, {3.737168168477805*^9, 
  3.7371681908420134`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "2"}], " ", 
   SuperscriptBox["p", 
    RowBox[{
     RowBox[{"-", "1"}], "+", "k"}]], " ", "x"}], "+", 
  SuperscriptBox["x", "3"]}]], "Output",
 CellChangeTimes->{{3.737167396383621*^9, 3.737167416159848*^9}, {
   3.737167455931408*^9, 3.737167500700523*^9}, {3.7371675414757977`*^9, 
   3.737167619309624*^9}, 3.737167664936905*^9, {3.737167824845166*^9, 
   3.737167853470373*^9}, 3.7371680729477057`*^9, {3.737168161563098*^9, 
   3.7371682004125657`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"d", ",", 
   RowBox[{"e", "+", 
    SuperscriptBox["p", 
     RowBox[{
      RowBox[{"-", "1"}], "+", "k"}]]}], ",", 
   RowBox[{"f", "+", 
    RowBox[{"2", " ", "d", " ", 
     SuperscriptBox["p", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "k"}]]}]}]}], "}"}]], "Output",
 CellChangeTimes->{{3.737167396383621*^9, 3.737167416159848*^9}, {
   3.737167455931408*^9, 3.737167500700523*^9}, {3.7371675414757977`*^9, 
   3.737167619309624*^9}, 3.737167664936905*^9, {3.737167824845166*^9, 
   3.737167853470373*^9}, 3.7371680729477057`*^9, {3.737168161563098*^9, 
   3.7371682004195366`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FactorHeckeOperator", "[", 
  RowBox[{
   RowBox[{"27", "*", "16"}], ",", "k"}], "]"}]], "Input",
 CellChangeTimes->{{3.721958888418559*^9, 3.721958939780402*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    SuperscriptBox["4", 
     RowBox[{
      RowBox[{"-", "1"}], "+", "k"}]], "-", 
    RowBox[{"3", " ", 
     SuperscriptBox["2", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "k"}]], " ", 
     SuperscriptBox[
      RowBox[{"T", "[", "2", "]"}], "2"]}], "+", 
    SuperscriptBox[
     RowBox[{"T", "[", "2", "]"}], "4"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "2"}], " ", 
     SuperscriptBox["3", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "k"}]], " ", 
     RowBox[{"T", "[", "3", "]"}]}], "+", 
    SuperscriptBox[
     RowBox[{"T", "[", "3", "]"}], "3"]}], ")"}]}]], "Output",
 CellChangeTimes->{{3.721958893371749*^9, 3.7219589461086183`*^9}, 
   3.721966008664312*^9, 3.721966186074992*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"ApplyTpIterated", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1",
      ",", "3"}], "}"}], ",", "3", ",", "2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"ApplyTn", "[", 
  RowBox[{"10", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1",
      ",", "3"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"ApplyTp", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1",
      ",", "3"}], "}"}], ",", "5"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"ApplyTp", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1",
      ",", "3"}], "}"}], ",", "2"}], "]"}]}], "Input",
 CellChangeTimes->{{3.7219637314681225`*^9, 3.72196374362464*^9}, {
  3.7219638527199388`*^9, 3.7219638618943567`*^9}, {3.7219639034887*^9, 
  3.7219639203950915`*^9}, {3.7219648159322405`*^9, 3.721964821026101*^9}, {
  3.721964866542277*^9, 3.7219648669797816`*^9}, {3.7219649614679413`*^9, 
  3.721965085115197*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"8", ",", "3", ",", "Null", ",", "Null", ",", 
   RowBox[{"6", "+", "Null"}], ",", "Null", ",", 
   RowBox[{"2", " ", "Null"}], ",", "Null", ",", 
   RowBox[{"2", " ", "Null"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.72196374510892*^9, 3.7219637825938463`*^9, {3.7219638409227986`*^9, 
   3.721963862425503*^9}, 3.7219639209732037`*^9, {3.7219640115550203`*^9, 
   3.7219640261490035`*^9}, 3.7219640819357824`*^9, {3.7219641143424835`*^9, 
   3.721964122452001*^9}, 3.7219643152853365`*^9, 3.721964821932249*^9, 
   3.72196486765164*^9, 3.7219649489832616`*^9, {3.721964991999504*^9, 
   3.721965085646358*^9}, 3.7219656027607183`*^9, 3.7219660045392537`*^9, {
   3.721966188121892*^9, 3.721966190762553*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "4", ",", "Null", ",", "Null", ",", "Null", ",", "Null", ",", "Null", ",", 
   "Null", ",", "Null", ",", "Null"}], "}"}]], "Output",
 CellChangeTimes->{
  3.72196374510892*^9, 3.7219637825938463`*^9, {3.7219638409227986`*^9, 
   3.721963862425503*^9}, 3.7219639209732037`*^9, {3.7219640115550203`*^9, 
   3.7219640261490035`*^9}, 3.7219640819357824`*^9, {3.7219641143424835`*^9, 
   3.721964122452001*^9}, 3.7219643152853365`*^9, 3.721964821932249*^9, 
   3.72196486765164*^9, 3.7219649489832616`*^9, {3.721964991999504*^9, 
   3.721965085646358*^9}, 3.7219656027607183`*^9, 3.7219660045392537`*^9, {
   3.721966188121892*^9, 3.721966190778186*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2", ",", "1", ",", "Null", ",", "Null", ",", "Null", ",", "Null", ",", 
   "Null", ",", "Null", ",", "Null"}], "}"}]], "Output",
 CellChangeTimes->{
  3.72196374510892*^9, 3.7219637825938463`*^9, {3.7219638409227986`*^9, 
   3.721963862425503*^9}, 3.7219639209732037`*^9, {3.7219640115550203`*^9, 
   3.7219640261490035`*^9}, 3.7219640819357824`*^9, {3.7219641143424835`*^9, 
   3.721964122452001*^9}, 3.7219643152853365`*^9, 3.721964821932249*^9, 
   3.72196486765164*^9, 3.7219649489832616`*^9, {3.721964991999504*^9, 
   3.721965085646358*^9}, 3.7219656027607183`*^9, 3.7219660045392537`*^9, {
   3.721966188121892*^9, 3.721966190778186*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2", ",", "0", ",", "0", ",", "0", ",", "3", ",", "Null", ",", "Null", ",", 
   "Null", ",", "Null"}], "}"}]], "Output",
 CellChangeTimes->{
  3.72196374510892*^9, 3.7219637825938463`*^9, {3.7219638409227986`*^9, 
   3.721963862425503*^9}, 3.7219639209732037`*^9, {3.7219640115550203`*^9, 
   3.7219640261490035`*^9}, 3.7219640819357824`*^9, {3.7219641143424835`*^9, 
   3.721964122452001*^9}, 3.7219643152853365`*^9, 3.721964821932249*^9, 
   3.72196486765164*^9, 3.7219649489832616`*^9, {3.721964991999504*^9, 
   3.721965085646358*^9}, 3.7219656027607183`*^9, 3.7219660045392537`*^9, {
   3.721966188121892*^9, 3.721966190778186*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FunctionPowerSeries", "[", 
  RowBox[{
   RowBox[{"Tanh", "[", "x", "]"}], ",", "10"}], "]"}]], "Input",
 CellChangeTimes->{{3.721966401424155*^9, 3.721966414018204*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "1", ",", "0", ",", 
   RowBox[{"-", 
    FractionBox["1", "3"]}], ",", "0", ",", 
   FractionBox["2", "15"], ",", "0", ",", 
   RowBox[{"-", 
    FractionBox["17", "315"]}], ",", "0", ",", 
   FractionBox["62", "2835"]}], "}"}]], "Output",
 CellChangeTimes->{3.72196641498693*^9}]
}, Open  ]]
},
WindowSize->{706, 504},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
ShowSelection->True,
FrontEndVersion->"9.0 for Microsoft Windows (64-bit) (January 25, 2013)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 17343, 406, 1612, "Input"],
Cell[CellGroupData[{
Cell[17925, 430, 523, 9, 72, "Input"],
Cell[18451, 441, 393, 10, 33, "Output"],
Cell[18847, 453, 502, 14, 33, "Output"],
Cell[19352, 469, 539, 15, 33, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19928, 489, 435, 9, 52, "Input"],
Cell[20366, 500, 513, 12, 33, "Output"],
Cell[20882, 514, 633, 16, 35, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21552, 535, 187, 4, 31, "Input"],
Cell[21742, 541, 793, 26, 35, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22572, 572, 1205, 29, 92, "Input"],
Cell[23780, 603, 753, 13, 31, "Output"],
Cell[24536, 618, 691, 12, 31, "Output"],
Cell[25230, 632, 688, 12, 31, "Output"],
Cell[25921, 646, 679, 12, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[26637, 663, 194, 4, 31, "Input"],
Cell[26834, 669, 330, 9, 48, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
