(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     56596,       1043]
NotebookOptionsPosition[     55935,       1017]
NotebookOutlinePosition[     56298,       1033]
CellTagsIndexPosition[     56255,       1030]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{
   "For", " ", "every", " ", "terminating", " ", "continued", " ", "fraction",
     " ", "x"}], ",", " ", 
   RowBox[{
   "there", " ", "is", " ", "an", " ", "associated", " ", "element", " ", 
    "of", " ", "SL", 
    RowBox[{"(", 
     RowBox[{"2", ",", 
      RowBox[{
       RowBox[{"\\", "mathbb"}], 
       RowBox[{"{", "Z", "}"}]}]}], ")"}], "\[IndentingNewLine]", "by", " ", 
    RowBox[{"T", "^", 
     RowBox[{"{", 
      RowBox[{"b_", "1"}], "}"}]}], 
    RowBox[{"ST", "^", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "b_"}], "2"}], "}"}]}], 
    RowBox[{"ST", "^", 
     RowBox[{"{", 
      RowBox[{"b_", "3"}], "}"}]}], 
    RowBox[{"S", "\\", 
     RowBox[{"cdotsT", "^", 
      RowBox[{"{", "b_max", "}"}]}]}], "S", "\[IndentingNewLine]", "It", " ", 
    "has", " ", "the", " ", "property", " ", "that", " ", 
    RowBox[{"it", "'"}], "s", " ", "action", " ", 
    RowBox[{"on", " ", "\\", "infty"}], " ", "gives", " ", "back", " ", 
    "x"}]}], "\[IndentingNewLine]", "*)"}]], "Input",
 CellChangeTimes->{{3.72695276465983*^9, 3.7269529239487505`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ModularS", ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "0"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ModularT", ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"RationalFracToModular", "[", 
   RowBox[{"x_", ",", "maxDepth_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "contFrac", ",", "intPart", ",", "i", ",", "length", ",", "returnVal"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"returnVal", "=", 
      RowBox[{"IdentityMatrix", "[", "2", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"contFrac", "=", 
      RowBox[{"ContinuedFraction", "[", 
       RowBox[{"x", ",", "maxDepth"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"intPart", "=", 
      RowBox[{"contFrac", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"Print", "[", "intPart", "]"}], ";"}], "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"contFrac", "=", 
      RowBox[{"Rest", "[", "contFrac", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"Print", "[", "contFrac", "]"}], ";"}], "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"length", "=", 
      RowBox[{"Length", "[", "contFrac", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", "1"}], ",", 
       RowBox[{"i", "<=", "length"}], ",", 
       RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"returnVal", "=", 
         RowBox[{"returnVal", ".", 
          RowBox[{"(", 
           RowBox[{"MatrixPower", "[", 
            RowBox[{"ModularT", ",", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{"-", "1"}], ")"}], "^", "i"}], "*", 
              RowBox[{"contFrac", "[", 
               RowBox[{"[", "i", "]"}], "]"}]}]}], "]"}], ")"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"returnVal", "=", 
         RowBox[{"returnVal", ".", "ModularS"}]}], ";"}]}], 
      "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"returnVal", "=", 
      RowBox[{
       RowBox[{"MatrixPower", "[", 
        RowBox[{"ModularT", ",", "intPart"}], "]"}], ".", "ModularS", ".", 
       "returnVal"}]}]}]}], "\[IndentingNewLine]", "]"}]}]}], "Input",
 CellChangeTimes->{{3.726877755781764*^9, 3.72687783854214*^9}, {
   3.726877869980023*^9, 3.7268779521115804`*^9}, 3.726902187422373*^9, {
   3.7269023156742306`*^9, 3.7269023396290617`*^9}, {3.726902370892535*^9, 
   3.7269025334329824`*^9}, {3.7269025771280828`*^9, 3.726902581887765*^9}, {
   3.7269026409691753`*^9, 3.726902698310562*^9}, {3.7269027839006205`*^9, 
   3.7269028752451253`*^9}, {3.726902988435133*^9, 3.726902999764512*^9}, {
   3.7269033066526613`*^9, 3.7269033121277704`*^9}, {3.7269033625894227`*^9, 
   3.726903395677345*^9}, {3.7269034838722*^9, 3.726903488257752*^9}, {
   3.7269036019808545`*^9, 3.726903624263489*^9}, {3.7269045869762106`*^9, 
   3.7269046026853876`*^9}, {3.726904723713052*^9, 3.726904736106675*^9}, {
   3.7269047763600025`*^9, 3.7269048010112333`*^9}, {3.726904913640028*^9, 
   3.726904924407629*^9}, {3.726905023368665*^9, 3.7269050447842226`*^9}, {
   3.726905189442994*^9, 3.726905277325782*^9}, {3.726905675218919*^9, 
   3.7269056952987328`*^9}, {3.72690575673811*^9, 3.726905772177931*^9}, {
   3.726905974463478*^9, 3.7269059982288895`*^9}, {3.726906032373892*^9, 
   3.726906052192486*^9}, {3.726906093670879*^9, 3.7269061026802015`*^9}, {
   3.726952085427033*^9, 3.726952094083417*^9}, {3.7269523241997643`*^9, 
   3.7269523300748634`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"x", "=", 
   RowBox[{
    RowBox[{"Pi", "^", "3"}], "*", "E"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"result", "=", 
   RowBox[{"RationalFracToModular", "[", 
    RowBox[{"x", ",", "10"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"result", "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{"N", "[", "x", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"x", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"result", "[", 
      RowBox[{"[", "1", "]"}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], "/", 
    RowBox[{
     RowBox[{"result", "[", 
      RowBox[{"[", "2", "]"}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"N", "[", "x", "]"}]}], "Input",
 CellChangeTimes->{{3.7269025484721127`*^9, 3.7269025686308703`*^9}, {
   3.7269026211455245`*^9, 3.726902621958902*^9}, {3.7269029077398806`*^9, 
   3.7269029292690463`*^9}, {3.726903165250227*^9, 3.726903186645541*^9}, {
   3.726903253121337*^9, 3.7269032532594643`*^9}, 3.7269033149909735`*^9, {
   3.726903419500682*^9, 3.726903445573354*^9}, {3.7269035794061527`*^9, 
   3.7269035805560737`*^9}, {3.7269036862152395`*^9, 3.726903687595186*^9}, {
   3.7269049342245255`*^9, 3.726904947854538*^9}, {3.7269052971538053`*^9, 
   3.72690532218554*^9}, {3.726905390227124*^9, 3.7269054191409893`*^9}, {
   3.7269056588597383`*^9, 3.7269056613447375`*^9}, {3.726905703550832*^9, 
   3.726905704111858*^9}, {3.7269057938301673`*^9, 3.7269058861758394`*^9}, {
   3.726906028261056*^9, 3.7269060286301556`*^9}, {3.726906112249528*^9, 
   3.726906114077149*^9}, {3.726906174634577*^9, 3.7269063391307173`*^9}, {
   3.7269521168180456`*^9, 3.726952149710878*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"-", "16133099"}], 
      RowBox[{"-", "3180112"}]},
     {
      RowBox[{"-", "191414"}], 
      RowBox[{"-", "37731"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.7269025704397*^9, 3.726902585123*^9}, {
   3.7269026225701027`*^9, 3.7269027053189745`*^9}, {3.726902790178429*^9, 
   3.7269028768843307`*^9}, {3.726902924323183*^9, 3.72690292979889*^9}, 
   3.726903002906664*^9, {3.726903169596981*^9, 3.726903187381255*^9}, {
   3.726903255263299*^9, 3.7269032623599863`*^9}, {3.7269033551750364`*^9, 
   3.7269034502889743`*^9}, 3.7269034904484673`*^9, {3.72690358149343*^9, 
   3.7269036263265133`*^9}, 3.7269036886802855`*^9, 3.726904615183015*^9, {
   3.726904738185046*^9, 3.7269047448062973`*^9}, 3.7269048615702076`*^9, {
   3.7269049284731827`*^9, 3.726904948823417*^9}, 3.7269050480009193`*^9, {
   3.726905250847635*^9, 3.7269053227962837`*^9}, {3.7269053930750446`*^9, 
   3.7269054198977523`*^9}, 3.7269056627426186`*^9, 3.726905705281808*^9, 
   3.7269057752702394`*^9, {3.726905823049799*^9, 3.726905887007826*^9}, {
   3.7269059804545283`*^9, 3.726906054127327*^9}, {3.7269061055521145`*^9, 
   3.726906115265123*^9}, {3.7269061705850573`*^9, 3.7269062341046085`*^9}, {
   3.726906267516348*^9, 3.726906293875813*^9}, {3.7269063240638227`*^9, 
   3.7269063399886756`*^9}, 3.726951844644534*^9, {3.726952111958635*^9, 
   3.7269521506795535`*^9}, 3.726952333637384*^9}],

Cell[BoxData["84.28379846823243`"], "Output",
 CellChangeTimes->{{3.7269025704397*^9, 3.726902585123*^9}, {
   3.7269026225701027`*^9, 3.7269027053189745`*^9}, {3.726902790178429*^9, 
   3.7269028768843307`*^9}, {3.726902924323183*^9, 3.72690292979889*^9}, 
   3.726903002906664*^9, {3.726903169596981*^9, 3.726903187381255*^9}, {
   3.726903255263299*^9, 3.7269032623599863`*^9}, {3.7269033551750364`*^9, 
   3.7269034502889743`*^9}, 3.7269034904484673`*^9, {3.72690358149343*^9, 
   3.7269036263265133`*^9}, 3.7269036886802855`*^9, 3.726904615183015*^9, {
   3.726904738185046*^9, 3.7269047448062973`*^9}, 3.7269048615702076`*^9, {
   3.7269049284731827`*^9, 3.726904948823417*^9}, 3.7269050480009193`*^9, {
   3.726905250847635*^9, 3.7269053227962837`*^9}, {3.7269053930750446`*^9, 
   3.7269054198977523`*^9}, 3.7269056627426186`*^9, 3.726905705281808*^9, 
   3.7269057752702394`*^9, {3.726905823049799*^9, 3.726905887007826*^9}, {
   3.7269059804545283`*^9, 3.726906054127327*^9}, {3.7269061055521145`*^9, 
   3.726906115265123*^9}, {3.7269061705850573`*^9, 3.7269062341046085`*^9}, {
   3.726906267516348*^9, 3.726906293875813*^9}, {3.7269063240638227`*^9, 
   3.7269063399886756`*^9}, 3.726951844644534*^9, {3.726952111958635*^9, 
   3.7269521506795535`*^9}, 3.7269523336530037`*^9}],

Cell[BoxData["84.28379846824161`"], "Output",
 CellChangeTimes->{{3.7269025704397*^9, 3.726902585123*^9}, {
   3.7269026225701027`*^9, 3.7269027053189745`*^9}, {3.726902790178429*^9, 
   3.7269028768843307`*^9}, {3.726902924323183*^9, 3.72690292979889*^9}, 
   3.726903002906664*^9, {3.726903169596981*^9, 3.726903187381255*^9}, {
   3.726903255263299*^9, 3.7269032623599863`*^9}, {3.7269033551750364`*^9, 
   3.7269034502889743`*^9}, 3.7269034904484673`*^9, {3.72690358149343*^9, 
   3.7269036263265133`*^9}, 3.7269036886802855`*^9, 3.726904615183015*^9, {
   3.726904738185046*^9, 3.7269047448062973`*^9}, 3.7269048615702076`*^9, {
   3.7269049284731827`*^9, 3.726904948823417*^9}, 3.7269050480009193`*^9, {
   3.726905250847635*^9, 3.7269053227962837`*^9}, {3.7269053930750446`*^9, 
   3.7269054198977523`*^9}, 3.7269056627426186`*^9, 3.726905705281808*^9, 
   3.7269057752702394`*^9, {3.726905823049799*^9, 3.726905887007826*^9}, {
   3.7269059804545283`*^9, 3.726906054127327*^9}, {3.7269061055521145`*^9, 
   3.726906115265123*^9}, {3.7269061705850573`*^9, 3.7269062341046085`*^9}, {
   3.726906267516348*^9, 3.726906293875813*^9}, {3.7269063240638227`*^9, 
   3.7269063399886756`*^9}, 3.726951844644534*^9, {3.726952111958635*^9, 
   3.7269521506795535`*^9}, 3.7269523336686277`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "The", " ", "matrix", " ", "elements", " ", "of", " ", "the", " ", 
    "associated", " ", "element", " ", "of", " ", "the", " ", "modular", " ", 
    "group", " ", "are", " ", "messily", " ", "dependent", " ", "on", " ", 
    "the", " ", "input", " ", "rational", " ", "number"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"RationalFracToModular", "[", 
       RowBox[{"x", ",", "15"}], "]"}], "[", 
      RowBox[{"[", "2", "]"}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "0", ",", "1"}], "}"}], ",", 
    RowBox[{"PlotPoints", "\[Rule]", "20"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.726952314309145*^9, 3.726952317902839*^9}, {
  3.726952394872508*^9, 3.726952433826109*^9}, {3.7269524892354507`*^9, 
  3.726952544642377*^9}, {3.7269527182538815`*^9, 3.726952718769511*^9}, {
  3.726953109828421*^9, 3.7269531503132906`*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ContinuedFraction", "::", "incomp"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Warning: ContinuedFraction terminated before \[NoBreak]\\!\
\\(15\\)\[NoBreak] terms. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/ContinuedFraction/incomp\\\", ButtonNote \
-> \\\"ContinuedFraction::incomp\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{{3.7269524051695027`*^9, 3.7269524344667425`*^9}, {
   3.7269524908604774`*^9, 3.7269525454549146`*^9}, 3.7269527198007765`*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], 
    LineBox[{{5.2631578947368416`*^-8, -1.}, {0.0000719015593234677, 
     5.402982353139566*^7}}], 
    LineBox[{{0.050201329825661896`, 5.402982353139566*^7}, {
     0.050621284151315234`, 1.2088591*^7}, {0.051478771896638006`, 
     4.0583913*^7}, {0.05158691089862833, 5.402982353139566*^7}}], 
    LineBox[{{0.10507170126084464`, -3.716885100598675*^7}, {
     0.10550049985197228`, 1.3250923*^7}, {
     0.10630116333696404`, -1.2607783*^7}, {0.10710182682195579`, 
     2.2555619*^7}, {0.10790249030694755`, 216881.}, {0.10850274873152958`, 
     5.402982353139566*^7}}], 
    LineBox[{{0.15010871198021833`, 5.402982353139566*^7}, {
     0.1503376550115108, 609794.}, {0.15113831849650256`, 650477.}, {
     0.15193898198149433`, 1.768789*^6}, {0.1527396454664861, 348567.}, {
     0.15354030895147786`, 1.5853687*^7}, {0.1543409724364696, 
     3.5236379*^7}, {0.15514163592146135`, 6.476888*^6}, {0.1559422994064531, 
     2.836158*^6}, {0.15674296289144488`, 256675.}, {0.15752792053715825`, 
     6.341479*^6}, {0.15831287818287165`, 6.809206*^6}, {
     0.15876457972248115`, -3.716885100598675*^7}}], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQAWIQPcs0h6eA45R9nI/Dn/zDnY4y551SCsVP2QOlGCal
mzvKG/0Q1zKE8FfYsDgqTV17+pEXmP8g5FWyo9qPpPrZKRB5gVWfHTSjJYxD
6iB8ng2qjqciuRmtZ4H5Ds67YhxzIv6dU9wG5jdMe+/syBv+cQ7HJYj6iO3M
jutCn2S9fwvmH/jxN8YxIOS6xTXO0yC+wF75csePQafY9qqC+Q+WcCY4Tgrc
e2WxI5jPkBeo5GgSsGFRVyyEv2uK5cGrfosLCishfA9pa8cy32l2EVPB/IZ1
oUWOEj6dPPYbwfwbfwuaHHd61dxSPQtRP0tcyzHKM38Fz0sIf9E0K8f3q2fV
HP922v6EE88Ms52NBwHOaHdc
     "]], 
    LineBox[{{0.2586063220949438, -3.716885100598675*^7}, {
     0.2589210597780579, -3.082117*^6}, {0.25977254842659814`, 40624.}, {
     0.2606240370751384, 3.1976145*^7}, {0.2614755257236787, 219271.}, {
     0.262270190111888, 2.311639*^6}, {
     0.2626601578643523, -3.716885100598675*^7}}], 
    LineBox[{{0.3075728276054154, -3.716885100598675*^7}, {
     0.30836072462802516`, 347434.}, {0.3091553890162344, 59779.}, {
     0.3099500534044437, 1.3632761*^7}, {0.31074471779265295`, 72175.}, {
     0.3115393821808622, -2.1093131*^7}, {0.3123340465690715, 155164.}, {
     0.31317836227090795`, 5.402982353139566*^7}}], LineBox[CompressedData["
1:eJw902tIk1EYwPE3L+Awo/BalCIuTSVNJ8OSbe+j4uZdp9DKJU7dUNSmkrOZ
mi0RnVZLArMkR0SG0YWw1LTYJoaFog1z85Jpmnl3eEldXtJzoA+Hw4//wznn
y3FOFnOFJgRB0PbW/s7n8xZNvw6wEiPILXFHBciCBEvbQwOsvaQgTuerY7QT
B4/NIBMiapHaUSDyoK8jX3VKrYD5pWk211yHejPlHLQVZwgvW2Mr9GYgt1qU
yZ2xDZtWwKvLVj71Rj7T/PGa2tVz5YOGgVzS5xoGq615w6PhyErJhhg0nI0N
4wXkGLfHxXBXV2Bnn4bPu7jsC0mibRpNgmzIspKqvdaux0aX4k5a6sl3oTu3
3auxn3VTgPmosNtUiS1qosOnZSNl9AUyyXLhQSRbym5pw+8xBgVD/8P10urP
eD57a4fkG/I0mTpsGzN7mAxe3Q35hZwULUqBzNpchvMKsipKLoTVBUPBX0K/
77H7zcnqwkBxy7dDyITFb1Mwq1lYe3UcuSSKjIequQya3AOZTHkTCzbkbHaq
P57PrHSCuntpL5kheL4+IhioM1NzDvG4q7L6yecMofuKAPfGOhJ8qydEPWLc
e5kB8H5K8KShCHvE1hECA8bGb1RiX3E7Al/uJDrxa7H/UL2AOznCpzdgx42c
hSH/hAeH32KXDM+RybcGdbMabDJES86On7ft7MOeMneBXPoAt34UO9cPwCiP
V0jnsasY1iD7oe2JM+L3XuoKBYpfrKWXxSDyJpkPivJejoUdMlFa6wcO3yPL
frpg82bMQOnT3dHugzxtkl4Op8rCDtSwcG9vOgqvh7qYOZHISm1YEvh7swvD
E3DnqKhq1c3O1pPp2AapJ3D0Qeu7Eny/5EQONKbIKsaLBv//j3/fszu/
     "]], 
    LineBox[{{0.4144341309195882, -3.716885100598675*^7}, {0.4147979664938204,
      383377.}, {0.4156434560455782, 124282.}, {0.41648894559733596`, 
     765713.}, {0.41733443514909374`, 211775.}, {0.4181799247008515, 
     1.2290975*^7}, {0.4190254142526093, 21445.}, {0.4198709038043671, 
     1.222964*^6}, {0.4207163933561249, 41011.}, {
     0.4215618829078826, -3.0111489*^7}, {0.4223505481993094, 158797.}, {
     0.42313921349073613`, -1.2184243*^7}, {0.42392787878216287`, 950289.}, {
     0.42471654407358966`, 24607.}, {0.42550520936501646`, 4.649607*^6}, {
     0.4262938746564432, 4.670236*^6}, {
     0.42708253994786993`, -1.1868968*^7}, {0.4277814514048056, 
     5.402982353139566*^7}}], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQA2IQPbvkRuZ517v2J5x4ZpjtbDz4TuSBnpPvXXugFIPO
BDtHldUnRPWiwHyDgHlljtGOG/9IpkPkX5U5Ok66PvMxawmYv0D3a77jidym
Ux8bIPKlTnGO/5izN97thcjvkcl1NJ0VPOPkLDC/Qd014mCOgU391uVg/oGr
iYWOi46ppC3cAuGfqg1wvBHD69t7EGIew7SrDvyfvxpXnoPwVzRLO7p13pNK
vQ0xz9vGxbFG/jhj4AswX4B9W7Xjpq3rX9h8hajnV7J2fOk947wG0z0wf4GI
haPCo4ZtIvwQfgYvp2NYReZcBhkI//LROMcevqCWNxpg/gdh58KDh5dYZd8w
BfM3zJCvOHiCwyn+tjOYf2DPtIqDl2zEV3P43IOHJwBj3If9
     "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQA2IQ/XhP14qYtQ/s43wc/uQf7nRkWl58y3HjA3ugFMOy
XcqOLJHlIc47IHyFwp8O7NzV51z2Q/i/vJQdufbWebgdA/Mb/vp4OPLkNx1y
PwvmH/DbHOTIr9hm43kFov7+fnNHocud27xuQ/gcBzgc3yx1Yr36EMzPKP3Y
7His4ndw/AuIfo2WaMcF3lsWvXwH5i9IyE11rJLL/Vj8FcwPCM8tdgz5qOrw
7zfEPIlYFke9I/f6Opgegt3z2MTLkWP69LtCnGC+w5LsMMfHmQE6c/nB/AKL
44UH99lwVquLgfkJj86kOc7gP3Ryo8xDiH97uRyLHlVJ2ChD+CU/rR19thqn
H9OE8PseaTiqdbzZGmAAMT9PIMaRIXopy20zML/CSKXd8ZZuXHCqLZj/o8+9
03ELg/ii984Q/R6tTI59l89/qPQC8wUOllQ6ZizrsGcJhMh3eCs7OlU69vWF
g/kK505mOcr4/LojEQfmP3iVnez4TW6z9uIUiHp3VkPHgl0bpkamP7Q/4cQz
w2xn40EAE9G0Gg==
     "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGDQAmIQLXT4/pwvGo/s43wc/uQf7nSMWy6yJUn/kT1QioGr
xcHRouos01tTCF86y+GgkG9bYLkNmH/Cub3N8Y28/QJGZzBfYeP1DMfjn76/
6/aEyGubNDguOrrBViwAon/NNxHHmhmZPQvCIPxJx4wdw7KVbmvFQvg1eyQd
Dexua25NhvAfND134BKcUmGfBeHvuMnu+OSxz/GTBWD+gSsnwhz3bWMVCymH
yM+Yy+c4o3Nfyr1aCL+3wdjR3770sHsL1DyHFw5sX7WVNnZB+AmbGRz3rHrU
IDURwj/w7qpDccLM+83TIfwXDkyOWmIBdm/nQvhfhEUcH5xmmxu2BMxvKJH1
c5zeuPf3/lUQ93zYHezoZ14SpbkRol4mVs+R9a3WzknbwXyH1QLRjnsWPRT/
sxciHyD436E4YkZZ6hEI3yVV2FGLz//quVMQ/oI7rI4PD7OaWFyE8FPOSDvO
qNwzaeF1aPiJ6jv66Rd/5LoH4Us8k3VkfaoZUPIEzNeQutPmuGfWg3V3X0Hi
J8Qm0bEoYDqv+0cw/4KvaaWjJptfzobvEP2FmWaOD3aznJb8B+Gf4HFynF64
W7OZ5TGYfzDQ2NFPvajjDReEL9Co7Mh6V+N5qCCE38B22mHPpPuu+8Uh/Blv
OR2LPaYt0ZAD8zuefm44qPXPh3mSCoRvIt7m+GAzc9JvLYj6L4ukDt66Eszu
pf/Y/oQTzwyznY0HAf80+ns=
     "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAWIQfWPqfk/1nY/t43wc/uQf7nT0Y897UrTvsT1QikHA
RtCRZa+K850jED6D3kaH3UW3F7qehvA3GH9yKNKYxLD+IoSfIMTrqHHPI17i
BoTf8OSgw/3J//c23oPwM7YKOE7z3Cbz+gmEvyVcxtH3f051yGuo/FJ+R5at
yrf2foTwDQ+aO+7OumWh/gPMP1BckuhYpDBx+oR/EPmCRBFHzWvu336yPAHz
Y895Oj7o/heSzA3mJ3BcSnSc5rh18xlBiPyCRZ8dfL9nC5lJQPgz1jA5vhHe
9F1LHsJ/kP7Qocvgxx15NQh/g6Cgo4av3SERXQhfhs/U8Vhmy3JOEzDfwc0v
yTGl7VTPPyuIfEP3KwfmxQJFnx0hfLY/9o6L9oeFv/CA8BW+cjo63Jljc9cf
oj/EM8bx3o9HipfCwHyFDyypB2tENdmPx4L5B8Qych2ljPLf7E6B6J8mqeS4
02/rxQ3ZEL6thYVjRPbvbUuLIPwdSwQcv7U7zplVCeErFag4TlnS3tjfAOG3
fFR2NDp4Nq2lHcKfNV/H8cJdYZ/KPgg/oZLVMf9XpGHeVIh7vv1IcOQTXyCW
PAfM/7CqucLxl85DK5uFT+xPOPHMMNvZeBAAO+HXKA==
     "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQAmIQrfFok+y8PU/tTzjxzDDb2XiQ46TClgkHntoDpRgs
bAQdlz1Nm9l6HMIPCRB3dGFaW1d1DsJ3OWbo+Fjuc3L+VQj/wrtPDhEx72Tf
3gbzF5ws6HQ8N/Pl9axHYL7B086igy7Xn0x88QLML/gmW+S4S+SBd9p7iP4j
AQKOBkG3WZ98hfAFcoIPLu2/tj/xD4Q/YZa0o9TZi5X3mZ6B+A8SE7IdJ3Cd
NY7lBPMZDmhcc2DzOPH2Fj+Y/yPGu/FgTevh5RFiUPkbjx0+HdqXeE0GzHdI
uxfrmM6wSzpEGSL/N9jK8Y7t1qsXNcH8CwKrKhyDqjf0+xtA5I1qbRxP7Fjt
edYMzF/g2Zh60O7bMmZvW4h7jlVVO24xXrT3hDNEvW6ZqaNW4dxyNy+o/W0X
HBasm2F4JADCX1Mq6ij6ZvJrx3Awv2HxNy/H5qcnU2NinsHjAwBak6qX
     "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGDQBWIQrbZjYVYww3P7OB+HP/mHOx3r0oU7W9ie2wOlCjjD
ih2/LOFzZuIF8xtmLXVwzHrE+bdeGMxnENj0yeGBPOv2v5IQ/vklfgfDYhkK
qxUg/IQIZsfTs35r/VSD8DWeMjk63Pj2pEwXwq8IYXPcJvpp3hdjMP/A7PfZ
jjrBbyOKrCDyDYvuOSya8ELogwOE/89B1VHi3OMzue5gfsLqnbmOvdz32177
QuT3dho4MnnecsgMgfADjL44VLRd/fUsCsIvajN2fHf4wpaURAjfQlHJMYXx
TN6jdKh9Lw443LI7rpGQB+F/uPbLwb/m0KO7JRA+5x4jxzUKvsrPq8F8A3/h
goNcR68nf2iCyEskyTmmZyYt+dkJ4T+6oeR4hPftE6aJEP6ei9KOipvKVXlm
QPj7jmo51oUxpYnOh/CjV9s43v7Vs0xuGSS8P4W6O1rMF3+uvhYin7vQ1nGq
8yJ1wy0QebOOrIOfnutkWO2GyF82MHYM6Nm+wvkQhP/xvonjWgOnlz4nIeql
Hzg4cl09oxl2AcKPZao9mFEZnhV/HaJ+hg6r41HZR6sy7oH5M1IrWh2VDuW8
LnwKkedYweFYn/Zdu/oNmG+h3d7keIerKaflMyQ8pv2scrRaz7O29xckfjrU
0g5OD57+dhrjC7B9tswBjl++K+ot4ADzOc7vaHcMmrMmbyU/mP/BZGqJ43oH
8/WbxCDqb+n6O/I8Pfh+tyyYz2C8PuxgZqePwVEVMH9BAVPNwZB1nfO1tF/Y
n3DimWG2s/EgAIVeFAU=
     "]], LineBox[CompressedData["
1:eJw9030s1HEcB/A77ZJNnsrDqO0Ubs7DJB2nuN9HRnGoy2MbeUzrDHUeQzsx
VJit8hCTh7IyKzLEPNyvmV0e8tBFY9O5qXkqkack0u9j/fHdd6+93599tu/2
NQyNEUQo0Wg07u75d383jtRbNpvhSZ1Uizmt6aTRSEjDmPUMbzeijYZzID1h
YUnORYusT8CkfqL1HEGZuOh1Hc500UU/XTHXpZ2EkrDcxi1PtFltOrmmrLvC
8EUHj80Tl+oqbdQD0UE6JmT9BfN4vXB0gUwF1FabmwyFlOV/PMNAWAJr7JuU
JVVl3iB16OfYJGM/7CWAicI30UGM1ljSh4ysqRaX7L19m3SQs6M2vPLRTr+Y
4DC4ZhfwiHJwkUUoPBalJ4eWYZ77UQvWdVXbhNV786u/Ce/2ws24Wtx/jeMN
DcGGp283YH6KsAI1Rl1K9hs0U22BiHrBaS/oQst1Z4l3HuRWSQ9lsUDTCUyW
3R2qBygzix0TILNwNK1Ohn2tGAtyyj6ks2kC+/1DfHD8PL/dqUDvmHuRpRkJ
POks9vd3G8MGiy4e/oGO8z0OPv33JePr6Omcw/A6Voc+vY2WBWqDunYlfGPM
Uq6QLhJRrWZ31lQpiz848aE3sPntziHMaXkSgqUE+1QM0CMRxpBZ03dW6xhl
qy9XRKBw8800MKUsTUvKAt6ivNvICvv+HRpQ9kDIsLTFPmkpIkf1V3x0HDEX
t20SGlWpNdvO6FufuOBmylj/6o6OrjKBzPo810EBWtZzFDptdYpbAigzk94L
yY3O8pknwZjHP7cFaxcWNycSbdh9DoQDr+7GRqOtaKvEU2+7cf94tHMIGyYn
JGxIRT8sMAC9sPMpphn4Hn4zriCYG+7TvEdZUswNIHNvXD6yWYB9syEe9Gwo
ohRFlInEq34kTSzs6C3Heb6+B9grrxxsfIbz/C4BGZefGlRaR7mC1Z0GU1tz
BwIbZ///v78Vm1x4
     "]], LineBox[CompressedData["
1:eJw9030s1HEcwPHrHPMQowdqSujmFE6lblee7sOhOyLHwnnsPFzbicpT4+iS
WYolE03tdhRLqfO0RWW7H1OWJrdJabQ6UR5W47KilvT9tP747bfX3t/f7/P5
/fFzkGSKUuk0Go27dv29c+pLks37ZnwH/NZf53Sfp+LuKVVeAzO+a4m2+6IL
1OxjLTBfEiscYgQw3K0G81Hs5VvYYArcqqVx9OGdjsAf0OgmJtEOMRwoChN4
PJ0l5jWpYqFrVHvhwQL2lH4mLMaLR2p+YGfbSsB1Ssc8t0psGZdSAGnpshyp
0Sw5z1EfApVe3x9mjr4dEAZj+XJr7iZiRbTan9pAN5Ta22J/k+8NIWUVD40d
iXkb49Og1NLaeMEZu/PjdaCpVUaPuaPb8sJhxY7VTHGINXnqOGp/k3q52Rt7
koUVZLhxhVV8dKl8F9zp1NTlB6PtRdM8nadgTiLCeR87E2Fbn9YzOAb7qQQX
OCYUl3skEavo79KgUqsbt5Vip0XR4Xm0zI2Rgb6pZQLjvb5wPhu/z0QoAB+p
fGikAPfrFUVSZ78wdvQU4/lOHxdoz6nIbCwjtlSaZcH8r82aikrsJvIgcCpR
WubWEjtftS+BJDPW8QQl7jsxEwV1Veq2wEacJ74cASNbuXT3FtyXPS2hLOo1
IpsO7KE+UVSQs+DWajfxcGRLIaVQa/WfNMT2dcup8Igj5g8/w/lxS07wrUdX
3TWEz+8Z4AM7QDaleoW9WBoGJ17oD5SNo1tZK7yGCHnp6Uni1urALBh/y3gd
M4u9sv4nz1pSwfJbQEf3GgDLdDCk4zv680Ej4LYbn2H+xnnqS0dBKA6svcaY
I52X95UXSy95YmSGVhhuh/S71Ic8K2KNrCMeikSrRjM2xElWQzK4suLlKrbD
89kNoZSqIT98kEmsSMwAaBN25Xq5/Ht/sp7Xu7h04/5e7JnsI3CS5u9pwJn7
/7/9ARQ+Tsw=
     "]], LineBox[CompressedData["
1:eJwt0H0s1HEcB/Df7EYLacTGyshOw3mWYXG/j4vSCMcpD3m6c6N1Hg/zuLs8
ZUbhPGz8ET0sZsaceZjkN+G2RJFFyEJmuIkpzEn6ffzx22+vvd/ffb97m8Ym
cePUCIJwPv3+/3M17pZyujbZCk+teuc+KWU9wGj93bvJPo0kX7b54CHwnBS+
o01IQnZIfy3J3tcR2sl1Y8kQLX9r6DOOeYjMC1Ijjjz6p2ibpDjxqQKGq8Bq
DvN9hivI2jJKG5dod5jpZ1Gvg+Xt2muYu4SS0KPamc7fQjMZkaB4aXu4vYu+
4uECc74i45hDfN9y9R1qY6+VM3WC9827x1GqxvV4jvoW3ed1cUDby7xCrkX7
gHtDCsZKfhdTj/aQajUB7GqaZmsNsd8U4gDgvnSsYYJ5nXocxf152SzLHHPh
I0vgl4fd3mChTRQrpPh6vSjckXZ0m44AihdnqsZdaUvmFd5UXZFerzuJfach
PXhjHbjY7o15WvwD6J+pUDPxo03y7IPgQ974tcog7D+bPyEXmOf91MLQRMoE
qfx4KzUtGs8nLAL8TS+qWxViHqfPhYvGwwM8EVpfHgymo8TyaBr6sVEKOCR6
aLhko8lde7hpkMtqkdDu6GRmUrzBvkCjEsyrxOYgFO5nlJWjty4ZQlT6+6tP
ZOjcbhbcL6ycKGzA86+eJkNAdWS2tJn2czE7FnyarczzW7AvSRwlPTsPPmd3
4L7slRxwGxrJy+xBcwruUY6TVRbiQeyvFxPA+h41kzxC+1NCSgEwlSypaBz3
qp0Np4xVh6yH03hfm20SGGiOzQq/4T7ECw7oGMkK+T+wv3YhCM5ZxNhFr5/t
Wf6LJFxsFiK20d0dznDofVQS+udsf5sjcpencAw5RnOkbrApqFniMpS0LZtN
YTUttsxfkzaZoxsAfUENu5a6SnakL6lKGi6Ffzn+TKI=
     "]], LineBox[CompressedData["
1:eJwt0Xs01GkYB/AflVWqUVokQmlKHTJpdM884uRE0YiQ7JhRbtM0bBbRrEu6
bNJ0sktZg3ZpT+Q4DtUsMq/sukQ7NrvUbDfRitwquaxttn2f/vid3/mc7/M+
7/s+r7XwKP+QLsMwwo/f//8n51ZsjwsbdG5ymZvjpEwhMrfLI1ZHBp0/RoYR
ICVx+w5/b3GMWqB3QgBSkaO7WSK1iiXyhvAY5p1xKubFx0+QkJS2fKOzuP7U
NhkEyq94GMqpGa3ECfj5YeNzs6kLSpJCwaNs/Q+zFdTPzDaLwbVWx0uvCOt/
dDCBba33p3RL0Yw5A06a3GJtBfa/lCAD+/5w/rSSWh11Mx5WTnI/TKiw/m4F
B6z0Z1wfa0T7PVwLpiZq3zf3qbssM9NgATtPZ/gP6mR+ig/M4UbeGPgL/bdJ
KMxw3RDQ94K6PCMvlkzzZ87q7cd+7pIl8C6kvfz5KLqLbQmDUkXQkwl0+c53
vJdfR+lrtOif9tuQJ5kbKzv1hmj/0SEP6MybJeiYRy3t0iQRdenvBu2LqOVZ
BnHQXJ1/q20JNa+GHUzqW8SilmXUVhY9R6H64SZWoy21usMkGir79KrvOlDH
3152Gm6MPzis2kA94r/qOCnWK1xYu52aycxaDYrPJXeUbtjfdLYfZNtsibzp
iTmvRstL5ljL03yoC8A+CiK3f3bTO5Badf5iAPHxGNRYhGB9hEoCW/0f6AyE
oc16bIB9SLnytoT6WWL6EWDF5O9Oj8U8VOkDE7L0L/lJuD/niC/pPhd12TIN
84MB26A1Z2/d67O4/89rwqGqaEOvUo7z87PlgaLCwuB0NtZbXXnLO1M3g7NP
ge4odIaY1ld+1kVotcQcDjz8LWmoBOfrviQWXF9WXa2uwHx6z2Kwf5vbdEaJ
73EvRQamTOqQr4pa0OsUATrzwhctb8T6mi1c6F+8Z/NIG7q6gUc62OsFtR04
ny7dg1DraHbqGw3mwvlSKOYxpfu70U3s+SDf/bLd5hVaasCChMDW8dFhfK8/
OUkgDKuwqHuP99+7Tkw8j+XsyPgX52WkCCTcFFlEwMxh6rTX3rA0M/QC24Ba
0KwSg37urqq3C6iTTz33hdFrDhqVKTWTz3OBR5XGOpmW1M+WvRdDA5lmH2BT
yx/ZJ0PZ/W7PVXbUVlqJlGRrmmLGHHG9vnAWJPeV5dRvRuu57yGRY1l3LgD2
682JJj66iT1B7pi3XeHAVlbInNVeeD5un4iwzXc6jPvi+VKdvYBla+fXEIT1
LbErYIJrlHRRhGYUy6HbZbIwOJK6gNMQBve8njauif50v/gAUhn0y+BEHLVK
/A8fFBElRr/KcL1tqS85/dXFTZfSMR8940+kaXFfCDLwflMHhCRQfjDd7hLO
8+p5Ebjm7SiZuoz3WeF1lNhdt21vLMD99nkAGN9ijWddw/5r3R2BaRgzF5ZR
S781SSD9ao3L2qpP/fvCyYPHJHy6Gut3DVhDTf+1zOZ6nMfCWhEpHj9f+V0z
5m6wg8hnHnskUuN5E029ScKCQIbTiXll7joiXMpjf3hMrV7tkEg817A97/VQ
Gz5NjgbuxrkxOQN43kkxkKVub7IPvcH13AAB0ed31a6bRJ9s8iajwXdeaLWf
5s2M1P0HtCVoFw==
     "]], 
    LineBox[{{0.0242097104046084, 5.402982353139566*^7}, {
     0.024519711648951212`, 530879.}, {0.02531066839144709, 1.2255109*^7}, {
     0.02610162513394297, 1.2683693*^7}, {0.026379195353400765`, 
     5.402982353139566*^7}}], 
    LineBox[{{0.07601886150553414, -3.716885100598675*^7}, {
     0.07634591651099823, 1.3519505*^7}, {0.077203404256321, 5.105021*^6}, {
     0.07806089200164376, 1.695625*^6}, {0.07891837974696653, 1.469721*^6}, {
     0.07977586749228929, 143665.}, {0.08030636283632199, 
     5.402982353139566*^7}}], 
    LineBox[{{0.12705173090908925`, 5.402982353139566*^7}, {
     0.12711841394674978`, 5.1667723*^7}, {0.12791907743174152`, 
     2.097709*^6}, {0.12871974091673327`, 1.5766051*^7}, {
     0.12952040440172505`, 246687.}, {0.13032106788671682`, 9.617125*^6}, {
     0.13112173137170857`, 2.4357427*^7}, {0.13192239485670032`, 
     1.606543*^6}, {0.1327230583416921, 6.849699*^6}, {0.13345035852803017`, 
     5.402982353139566*^7}}], 
    LineBox[{{0.22355935171072164`, -3.716885100598675*^7}, {
     0.2240100251879068, 4.803102*^6}, {0.22486151383644706`, 2.294092*^6}, {
     0.22571300248498732`, 4.571057*^6}, {0.2265644911335276, 2.2600192*^7}, {
     0.22741597978206787`, 6.234065*^6}, {0.22826746843060813`, 
     8.280409*^6}, {0.22911895707914842`, 150651.}, {0.22997044572768868`, 
     1.0134237*^7}, {0.23082193437622894`, -1.8479249*^7}, {
     0.23167342302476923`, 1.9248289*^7}, {0.2325249116733095, 2.735866*^6}, {
     0.23337640032184975`, -1.29256*^6}, {0.23422788897039004`, 262663.}, {
     0.23501430407560012`, -3.716885100598675*^7}}], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQBWIQ/fTh1zXsoZfsTzjxzDDb2XhwtWLKk6Uxl+yBUgd4
sqIcVz06/mVVJpjvEJIY4bhqsTbrhjIwf4N6S7njypR+0a3NYD7Dv2B9xxWq
n1V3TQDzGx7lpTiueBZmtn8uRN4yOP3g8uW73I6sgpjfwB7suCxDLvzkdoj5
t5oDHZdpNqWfOwJRf2DdS4elr56WX74I5hfMMyp0XLLas+PGPYj5Nqkxjkty
1s64+xrCf73A1XGxruDKRz8g5rm35h9c9K5k53PWy2DzqrksHRetv3HyjRCE
X2nj6riwwObWR3kwP2BhSsXBBYYLXn3Tgcg/OPzXYcEn5t+/LcH8AoUrhQfn
b07nZnQH8x/ceF/juPwj158VAZfh4QcA2UCRDg==
     "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQAGIQvaRgg8MSmav2J5x4ZpjtbDzY8mNizDTVq/ZAqYYJ
j8Mcg9pFqjYZg/kOKw0CHRXEpk8/5wjmL3jPn+v4fonk1lf+YD7D+WmhjvuM
51xiiwPzFb7LJR3sOST3QSkHwq89mnYwKnAhr30VmO9xl7fdUeOBsnZ0B8S+
vsXVjt/ylnmUT4Oo/7c3x/HoX420yUvA/ANysomOU3pWN6/fBOZvCPxW7Zgk
rbfw9AGI/dmcsY4Gqzbse34O4t5lt8sd/1sY32G+C+YLWN+tcjx3fOtP+dcQ
+e3TAw/OCbMQt/kJ0X/iW6Jj1tNdJhHs18D8S62ajhYltkElomD+hk77ioNs
zAfyJyiD+QXv7xc7Xp3o1LvGEMxPUMjOOrhE4eiqE/Zg/oPXmWkHi9a7n3ji
CzHP4AGbo+LpjpmTIq/Zx/k4/Mk/3OkIAHhBmx8=
     "]], 
    LineBox[{{0.44542265278948534`, -3.716885100598675*^7}, {
     0.4460105069421123, 1.5774523*^7}, {0.4467991722335391, 3.5656917*^7}, {
     0.4475878375249659, 2.0364901*^7}, {0.44837650281639263`, 
     3.5292485*^7}, {0.44916516810781937`, 1.79617*^6}, {0.44995383339924616`,
      6.872934*^6}, {0.45074249869067295`, 694412.}, {0.4515311639820997, 
     2.945243*^6}, {0.45231982927352643`, 447964.}, {
     0.4531084945649532, -3.6629033*^7}, {0.4538674961299274, 
     5.402982353139566*^7}}], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBWIQ3dlxMijpwn37E048M8x2Nh7MjJVgMbx13x4oteGS
c5Fj3kH5H8YvwHyGJ8vDHUtU1d+YfQPzG2amZTnudRH/IMP0ACyvczvI8cA3
qSw5Tgj/5LIyx0Mr5J7IC4D5D4JbCx2PRinFKYpD5C3OsTme4FG7oSQH5t94
d7vN8dQ+zSAVVTC/IXK+o+PZAt0zqjoQ/n3jOMcLSoZu6sYQ/c9tTRwvXzE5
oGEF5i/YdqXw4LU2CystRzA/4Gtc/cEbFjZbtD3A/AM+2+MO3n5lr6frD+bv
SPvd7HhvjvMKvTCIeRH7pB0f+LkrGcRCzNvglnzwMYP3HMMUMN+Be1WE47NN
fmLG2RD1NzazOr5MCZpgUgRxX/oNf8c3YmFcZpUQ9dsFAxzfnYhsMW+A8LMu
xzt+rIr9Z9EO0Z9hzuP4RSexwqoPwl/nb+H47V7KJ+upYL7BX6aSgz8nZOTY
zoHIXxD67vDHKeeZ3WIw32JXbKsjS82fh7VLHtjH+Tj8yT/c6QgAqASyDA==

     "]], 
    LineBox[{{0.5447965559613923, -3.716885100598675*^7}, {0.5451315811716502,
      1.892976*^6}, {0.5459299532055728, 303854.}, {0.5467283252394954, 
     960991.}, {0.5475266972734181, 261169.}, {0.5483250693073407, 
     1.526899*^6}, {0.5491234413412633, 55330.}, {0.549921813375186, 
     1.4499283*^7}, {0.5507201854091086, 3.170503*^6}, {0.5515185574430312, 
     2.137094*^6}, {0.552316929476954, 213019.}, {0.5531153015108767, 
     6.088255*^6}, {0.5539136735447994, 241525.}, {
     0.5546275025171677, -3.716885100598675*^7}}], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQA2IQbcYcdlXe+LH9CSeeGWY7Gw/6yRfKnzN/bA+UYpBd
l+rIclW9ztwOzFf4V5/uuLvr3p0FLmD+hUucxY5FDlOtubwh6vX4FB01v3nP
Kg4E8x0M98Q7PljN9PNOOETe/IuT4/TEneFucWD+AeN14Qf9xAu2rU+ByAv0
RTuynlUTlcyG8L3m6Tvuabpb3FQI4R9w+uBQZDHl0utyiPl6DsGOmu+8DEPr
IPIBRX8dHixmnLCvBcJnKDriMC1yxzv1bghfZIqsoy9/vu/EiRA+z0MdR5aj
qmt+TYeqr9/ssLvqDlfKPAg/44qzY5HB5MyzSyD8+ERDR81nnifMVkPsT60O
c3wwm0F9wUaI/O77Ro5vo1Y1PN/22D7Ox+FP/uFORwDkYYGk
     "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQAGIQXVNv8tBt5xP7OB+HP/mHOx1Vl/2boL3/iT1QimFB
vqLjkUMuZQrHIPwHl145JN3vihY9C+Y3eH70Ocjw54ID1xWIfAizoOM8CXG1
/7cg/A0LvzjYmMZyf3kI5iu8Mst3vB24+MOLFxD5C584HKvyXl69+x7CF5j1
20GiW3/3pW9g/oGOygrHbctLFxz/C5GvqtJ2DD2yu3UPy1OI+i1/Hb48YMze
yA3hJ+jwOk766x6wTAjMb5jO6+BoINVnOlsSzE+oX5pw8JzZFakJChD1R8JF
HHOCpRha1cH8A3zeIQe5CxKeVupB5E2XJTiu6ll2Ks8UzHe4dDHM0WPlm/XJ
NhDzZ+7zd3x21GhqhDNE/a83mo4tjyqqfL0gfAdrEUel//vinQIh/AX/sx1v
zLp1PDv8qf0JJ54ZZjsbDwIAtqmZKw==
     "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQAmIQvXlx6SOr+Gf2J5x4ZpjtbDzIkN4Vb5vyzB4oxbBh
Jb9j2ZJWyd1ZEH6Qnpvjm4cNly0KwXwHj2XBjknyNb3bysH8BWu+Zjpejyl3
N6mDqA94yenoM6uIcVMLhL91t/XBQ9dzd+t3Q/gKYm8cLEQzS9dOhPDFFik7
rgtK0deeAeHbepk7qkyIf7liHpifcGpnvePMs1GL1ZZC5BMmPXPg4w6LXbIa
zOeYodDg2OIRKK60CSKvEy/n+KvV5+L8HRD9c7dmHSw47N4tux/i3taIZsdn
DM6us49C3TOH1THazu6/xBkwv0Eyz8PxQrXlzmmXwHyFDXFJB912mhSL3ITI
GzZ4OO75pq876T5E/41ySUcjE+3n/M8g/AduHx1WFKot7H0D4b9SMHCUXa8Y
zf0Zol9Z0t1x0hsZ0c6fEPMdklMdtZu/XTz5/5l9nI/Dn/zDnY4A62mdPQ==

     "]], 
    LineBox[{{0.11789986091089895`, 5.402982353139566*^7}, {
     0.11831111561184043`, 217469.}, {0.1191117790968322, 1.7457459*^7}, {
     0.11991244258182396`, 1.1601073*^7}, {
     0.1207131060668157, -3.0842144*^7}, {
     0.12122564977666456`, -3.716885100598675*^7}}], 
    LineBox[{{0.16821154618760567`, -3.716885100598675*^7}, {
     0.16851732757714563`, 1.78819*^6}, {0.169302285222859, 1.9845373*^7}, {
     0.17008724286857238`, 3.5913881*^7}, {0.17087220051428575`, 
     3.551947*^6}, {0.17165715815999916`, 253983.}, {0.17244211580571253`, 
     1.182188*^6}, {0.1732270734514259, 1.0193499*^7}, {0.1740120310971393, 
     1.6118397*^7}, {0.17479698874285268`, 1.5414293*^7}, {
     0.17558194638856606`, 69637.}, {0.17636690403427946`, -1.5814991*^7}, {
     0.17715186167999283`, 116132.}, {0.1779368193257062, 3.0028771*^7}, {
     0.1783907739546856, -3.716885100598675*^7}}], 
    LineBox[{{0.219338235973004, -3.716885100598675*^7}, {
     0.21975258194520544`, 900581.}, {0.2206040705937457, 2.428491*^6}, {
     0.221455559242286, 1.009715*^6}, {0.2221037167171574, 
     5.402982353139566*^7}}], 
    LineBox[{{0.2729615507644077, -3.716885100598675*^7}, {
     0.27339549154681764`, 20271.}, {0.27419015593502694`, 3.4597679*^7}, {
     0.2749848203232362, 1.508596*^6}, {0.2757794847114454, -1.0792322*^7}, {
     0.2765741490996547, 82759.}, {0.27736881348786396`, 95227.}, {
     0.2781634778760732, 41339.}, {0.2789581422642825, 8.915843*^6}, {
     0.27975280665249175`, 2.1045712*^7}, {0.280547471040701, 270407.}, {
     0.2813421354289103, 3.62035*^6}, {0.28213679981711953`, 2.1806535*^7}, {
     0.28264548442413717`, 5.402982353139566*^7}}], 
    LineBox[{{0.3245672734287222, -3.716885100598675*^7}, {
     0.32525197743461376`, -5.129626*^6}, {0.3261131728256499, 
     1.6173971*^7}, {0.326974368216686, 4.5676143*^7}, {0.3278355636077222, 
     3.9569197*^7}, {0.3286967589987584, 2.3894437*^7}, {
     0.3293083587620274, -3.716885100598675*^7}}], 
    LineBox[{{0.42809521234521064`, 5.402982353139566*^7}, {
     0.4286598705307235, 3.2697796*^7}, {
     0.42944853582215026`, -1.3598109*^7}, {0.430237201113577, 
     3.1089736*^7}, {0.4310258664050038, 1.0521292*^7}, {0.4318145316964306, 
     2.1661793*^7}, {0.4326031969878573, 2.415211*^6}, {0.43339186227928406`, 
     4.4040317*^7}, {0.43418052757071085`, 1.418919*^6}, {
     0.43496919286213764`, 2.304823*^6}, {
     0.435729419317355, -3.716885100598675*^7}}], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQBWIQXR/yZP7X4Hv2J5x4ZpjtbDx45UKA+8P4e/ZAqYSe
wkTHWyYR1k9ywXwGo9dajg9mxOs/rwbzH4RNTTz49E+a8qtOML/h6xMHx1cJ
eeJvp4P5BbaLqhw/HCnl/rAUzD+wzbXO8ZtG7f9PmyHmtX41d/zd0/L560EI
36ZQ1JHhY/fzH+chfNsYU0e20Mm3f9+F8G/IsDjy7Jx1/t9riH1LrX0cBWUX
HWb8BeYv2GiR4yjWuHI7C8d9EF9h76kCR5mnG1azi4H5DAumch5U8twxn0sF
zJ9g0lzmqL52/2ReI4h8dZyzo47g8XYBBzDfwNW5yNGo9Fy1sB+E7zij4KDF
zav5YjFgvsf2kAbHO3LLmCYm3beP83H4k3+40xEAx2yHsg==
     "]], 
    LineBox[{{0.8508735585968975, -3.716885100598675*^7}, {0.8513869763210918,
      322428.}, {0.8521733501614495, 2.9182113*^7}, {0.8529597240018072, 
     815076.}, {0.8537460978421648, 1.900551*^6}, {0.8545324716825224, 
     194662.}, {0.8553188455228801, 4.438858*^7}, {0.8561052193632377, 
     2.3480393*^7}, {0.8568915932035954, 2.4565517*^7}, {
     0.857677967043953, -1.7789937*^7}, {
     0.8584274374168642, -3.716885100598675*^7}}], 
    LineBox[{{0.03599649491660443, -3.716885100598675*^7}, {
     0.03638406278638941, 3.1056922*^7}, {0.037175019528885286`, 
     8.560399*^6}, {0.037965976271381166`, 978376.}, {0.038756933013877046`, 
     4.5860827*^7}, {0.0391504203212307, -3.716885100598675*^7}}], 
    LineBox[{{0.0914710868045855, 5.402982353139566*^7}, {0.09178069592680801,
      2.141921*^6}, {0.09263818367213078, 116982.}, {0.09349567141745355, 
     1.6242153*^7}, {0.09435315916277631, 5.3208955*^7}, {0.09521064690809908,
      2.7558273*^7}, {0.09606813465342184, 5.3328047*^7}, {
     0.09692562239874461, 1.7276505*^7}, {0.09778311014406738, 1.181881*^6}, {
     0.09864059788939014, 2.278281*^6}, {
     0.09949808563471291, -3.4840007*^7}, {0.10020422148526029`, 
     5.402982353139566*^7}}], 
    LineBox[{{0.14244745226886654`, -3.716885100598675*^7}, {
     0.14313168364658496`, 3.459283*^6}, {0.1439323471315767, 8.694029*^6}, {
     0.14473301061656846`, 4.9702407*^7}, {0.14553367410156023`, 
     5.102393*^6}, {0.146334337586552, -482614.}, {0.14713500107154376`, 
     4.614993*^6}, {0.1479356645565355, 5.382725*^6}, {0.14873632804152728`, 
     301621.}, {0.14896621260635692`, 5.402982353139566*^7}}], 
    LineBox[{{0.18868816106147965`, -3.716885100598675*^7}, {
     0.1889262263656936, 401146.}, {0.18971118401140696`, 1.256821*^6}, {
     0.19049614165712037`, 9.855008*^6}, {0.19128109930283374`, 383007.}, {
     0.19206605694854711`, 4.8460973*^7}, {0.19285101459426052`, 
     1.120103*^6}, {0.1936359722399739, 2.099708*^6}, {0.19442092988568727`, 
     5.081958*^6}, {0.19520588753140064`, 5.2786538*^7}, {
     0.19599084517711401`, 1.836846*^6}, {
     0.19677580282282742`, -2.8111246*^7}, {0.19754722368807778`, 
     5.402982353139566*^7}}], 
    LineBox[{{0.24707592482782137`, 5.402982353139566*^7}, {
     0.24785170734703438`, 8.075599*^6}, {
     0.24870319599557467`, -2.1696995*^7}, {
     0.24918523336552498`, -3.716885100598675*^7}}], 
    LineBox[{{0.3533242219623286, -3.716885100598675*^7}, {0.3536714253388067,
      428621.}, {0.3545326207298428, 43209.}, {0.355393816120879, 
     1.299896*^6}, {0.3559269175172829, 5.402982353139566*^7}}], 
    LineBox[{{0.4073613312804888, -3.716885100598675*^7}, {
     0.40803405007975824`, 104082.}, {0.408879539631516, -3.6888016*^7}, {
     0.4097250291832738, 2.738727*^6}, {0.4105705187350316, 1.930331*^6}, {
     0.4114160082867893, 717291.}, {0.41226149783854704`, -2.8405665*^7}, {
     0.4131069873903048, 637019.}, {
     0.4134722188733366, -3.716885100598675*^7}}], 
    LineBox[{{0.5547579123785319, -3.716885100598675*^7}, {0.5555104176126446,
      3.5523206*^7}, {0.5563087896465673, 11801.}, {0.5571071616804899, 
     191701.}, {0.5579055337144125, 846249.}, {0.5587039057483352, 
     1.6136882*^7}, {0.5595022777822578, 280317.}, {0.5603006498161804, 
     3.0318728*^7}, {0.5610990218501031, 416807.}, {0.5618973938840257, 
     416213.}, {0.5626957659179483, 6.581521*^6}, {0.563494137951871, 
     577699.}, {0.5642925099857936, 122977.}, {0.5650908820197162, 
     2.847703*^6}, {0.5658892540536389, -4.094651*^6}, {0.5666876260875615, 
     2.945374*^6}, {0.5674723411900886, 5.402982353139566*^7}}], 
    LineBox[{{0.6682149479935882, 5.402982353139566*^7}, {0.6687169364983274, 
     3.1544791*^7}, {0.6695661336957985, -2.2671408*^7}, {0.6704153308932697, 
     1.9826529*^7}, {0.6712578267494859, -3.716885100598675*^7}}], 
    LineBox[{{0.05625396377935553, 5.402982353139566*^7}, {
     0.0566236983685746, -2.1531921*^7}, {0.05748118611389737, 703204.}, {
     0.05833867385922013, -8.096893*^6}, {
     0.0591961616045429, -1.7178428*^7}, {0.060053649349865665`, 553222.}, {
     0.060873872846863616`, 5.402982353139566*^7}}], 
    LineBox[{{0.1115626544142537, 5.402982353139566*^7}, {
     0.11190580773190636`, 9.259019*^6}, {0.11270647121689813`, 
     6.249721*^6}, {0.11350713470188989`, 2.738797*^6}, {0.11430779818688164`,
      1.9156812*^7}, {0.1151084616718734, 4.7746959*^7}, {
     0.11589990820844288`, -3.716885100598675*^7}}], 
    LineBox[{{0.16243935167839813`, 5.402982353139566*^7}, {
     0.16302262405715195`, -7.388772*^6}, {0.16380758170286533`, 
     1.862484*^6}, {0.16452145788344955`, 5.402982353139566*^7}}], 
    LineBox[{{0.2634794932755181, -3.716885100598675*^7}, {0.2638595188883065,
      382571.}, {0.2646541832765158, 1.5135098*^7}, {0.26544884766472504`, 
     16587.}, {0.2662435120529343, 7.670955*^6}, {0.2670381764411436, 
     7.830929*^6}, {0.2678328408293528, 1.149228*^6}, {0.26862750521756207`, 
     1.8148324*^7}, {0.26942216960577137`, 1.834656*^6}, {0.2702168339939806, 
     6.399135*^6}, {0.27101149838218985`, -1.0572009*^7}, {
     0.27180616277039915`, 1.236749*^6}, {
     0.27224643379936647`, -3.716885100598675*^7}}], 
    LineBox[{{0.31845432802948387`, -3.716885100598675*^7}, {
     0.3192236096973607, 1.425211*^6}, {0.3200848050883969, 9.300857*^6}, {
     0.3207625602477423, -3.716885100598675*^7}}], 
    LineBox[{{0.028858351335379857`, 5.402982353139566*^7}, {
     0.02926545210392649, 1.3142288*^7}, {0.03005640884642237, 2.131226*^6}, {
     0.03084736558891825, 3.863539*^6}, {0.03163832233141413, 1.2875177*^7}, {
     0.03242927907391001, 1.2162065*^7}, {0.03322023581640589, 3.298923*^6}, {
     0.033384276830939676`, -3.716885100598675*^7}}], 
    LineBox[{{0.08377132592831583, 5.402982353139566*^7}, {
     0.08406330621890312, 5.539361*^6}, {0.08492079396422589, 4.995137*^6}, {
     0.08515757106352882, -3.716885100598675*^7}}], 
    LineBox[{{0.13551552252086185`, -3.716885100598675*^7}, {
     0.13592571228165912`, 4.687612*^6}, {0.13672637576665087`, 
     1.3202566*^7}, {0.13752703925164264`, 5.156855*^6}, {
     0.13832770273663442`, 1.497473*^6}, {0.13912836622162617`, 
     7.865161*^6}, {0.1399290297066179, 6.875271*^6}, {
     0.14055565137044013`, -3.716885100598675*^7}}], 
    LineBox[{{0.23514702389949033`, -3.716885100598675*^7}, {
     0.2359308662674706, -1.278739*^6}, {
     0.23678235491601085`, -1.9411911*^7}, {
     0.23763384356455114`, -2.6579257*^7}, {0.2384853322130914, 171021.}, {
     0.23933682086163166`, 1.105463*^6}, {0.24018830951017195`, 
     3.0506797*^7}, {0.2410397981587122, 84401.}, {0.24189128680725247`, 
     2.684458*^6}, {0.24274277545579276`, 1.1413592*^7}, {
     0.24359426410433302`, 1.4495173*^7}, {0.24444575275287328`, 
     1.7783778*^7}, {0.24529724140141357`, 1.185602*^7}, {
     0.2457948230602253, -3.716885100598675*^7}}], 
    LineBox[{{0.3996460165363966, -3.716885100598675*^7}, {
     0.4004246441139383, -7.238061*^6}, {0.401270133665696, -3.424364*^6}, {
     0.40211562321745375`, 4.3943458*^7}, {
     0.4028160284946332, -3.716885100598675*^7}}], 
    LineBox[{{0.0187759669912065, -3.716885100598675*^7}, {
     0.018983014451480054`, 4.302952*^6}, {0.019146582552746098`, 
     5.402982353139566*^7}}], 
    LineBox[{{0.12400908971754195`, -3.716885100598675*^7}, {
     0.1247164234917745, -6.621229*^6}, {0.12551708697676628`, 1.357847*^6}, {
     0.12605314464374562`, 5.402982353139566*^7}}], 
    LineBox[{{0.4357758074402349, -3.716885100598675*^7}, {0.4365465234449911,
      2.6236159*^7}, {0.4373351887364179, 1.8395284*^7}, {0.4381238540278447, 
     864986.}, {0.43891251931927144`, 3.706144*^6}, {0.4397011846106982, 
     1.102219*^6}, {0.440489849902125, 3.692723*^6}, {0.44127851519355177`, 
     1.500209*^6}, {0.4420671804849785, 381718.}, {0.4427352451760746, 
     5.402982353139566*^7}}], 
    LineBox[{{0.49110736258501503`, 5.402982353139566*^7}, {
     0.4917059763270296, 371834.}, {0.4925611726212833, 2.1383545*^7}, {
     0.493416368915537, -1.1800403*^7}, {0.4942715652097906, 4.5603382*^7}, {
     0.4951267615040442, 2.0033803*^7}, {0.4959819577982979, 750241.}, {
     0.49650446957501804`, -3.716885100598675*^7}}], 
    LineBox[{{0.8601840624295197, 5.402982353139566*^7}, {0.8608234624053837, 
     1.3745837*^7}, {0.8616098362457413, 2.8061438*^7}, {0.8623962100860989, 
     4.507543*^6}, {0.8631825839264566, 1.8447878*^7}, {0.8639689577668143, 
     4.239128*^6}, {0.8647553316071719, -1.0591131*^7}, {
     0.8653922122749177, -3.716885100598675*^7}}], 
    LineBox[{{0.91031480844215, -3.716885100598675*^7}, {0.9110423225697495, 
     7.360399*^6}, {0.911895227412934, 2.4060263*^7}, {0.9127481322561186, 
     2.7691029*^7}, {0.9136010370993032, 157363.}, {0.9144539419424877, 
     2.172736*^6}, {0.9153068467856722, 918504.}, {0.9161597516288568, 
     3.539219*^6}, {0.9170126564720413, 2.768386*^6}, {
     0.9178655613152258, -586721.}, {
     0.9186212633349518, -3.716885100598675*^7}}], 
    LineBox[{{0.04360056211264646, 5.402982353139566*^7}, {0.0442936302113482,
      731437.}, {0.04493965502647332, 5.402982353139566*^7}}], 
    LineBox[{{0.19758130935428578`, 5.402982353139566*^7}, {
     0.19834571811425417`, 410450.}, {0.19913067575996757`, 2.3408297*^7}, {
     0.19991563340568094`, -2.864878*^7}, {
     0.20070059105139432`, -1.296334*^6}, {0.20148554869710772`, 
     1.233349*^6}, {0.2022705063428211, 2.7990937*^7}, {0.20259223622855058`, 
     5.402982353139566*^7}}], 
    LineBox[{{0.2541573369157657, -3.716885100598675*^7}, {0.2546636165353565,
      489159.}, {0.2555151051838968, 5.1602053*^7}, {
     0.2563665938324371, -8.592114*^6}, {
     0.25721808248097733`, -1.8708362*^7}, {
     0.25742331220895903`, -3.716885100598675*^7}}], 
    LineBox[{{0.6712725211736338, -3.716885100598675*^7}, {0.672113725288212, 
     1.0542387*^7}, {0.6729629224856832, 2.799918*^6}, {0.6738121196831544, 
     422833.}, {0.6746613168806255, 3.874049*^6}, {0.6755105140780966, 
     1.5378714*^7}, {0.6763597112755677, -2.9948141*^7}, {0.6772089084730389, 
     2.052473*^6}, {0.6780581056705102, 857369.}, {
     0.678543163845622, -3.716885100598675*^7}}], 
    LineBox[{{0.05286840233193881, 5.402982353139566*^7}, {
     0.05319374738728354, -2.935157*^6}, {
     0.054051235132606304`, -3.2665359*^7}, {0.05490872287792907, 
     2.6107473*^7}, {0.05509635972808911, 5.402982353139566*^7}}], 
    LineBox[{{0.15935073409292072`, -3.716885100598675*^7}, {
     0.1598827934742984, 3.1092808*^7}, {0.1606677511200118, -1.0710158*^7}, {
     0.16145270876572518`, 9.277565*^6}, {0.16198504359655172`, 
     5.402982353139566*^7}}], 
    LineBox[{{0.3132139321239557, 5.402982353139566*^7}, {0.3140564373511438, 
     5.478216*^6}, {0.31491763274218, 775733.}, {0.3157788281332161, 
     4.6003898*^7}, {0.31655662553526465`, -3.716885100598675*^7}}], 
    LineBox[{{0.13360133903848387`, 5.402982353139566*^7}, {
     0.13432438531167562`, 9.696296*^6}, {
     0.13475713031510342`, -3.716885100598675*^7}}], 
    LineBox[{{0.014845091949249723`, -3.716885100598675*^7}, {
     0.015028230739000656`, -272221.}, {0.015819187481496536`, 
     2.1437321*^7}, {0.016610144223992415`, 4.5197681*^7}, {
     0.0166890188308202, 5.402982353139566*^7}}], 
    LineBox[{{0.06759005213570511, 5.402982353139566*^7}, {
     0.06777103905777057, 3.4358157*^7}, {
     0.06862852680309334, -8.119641*^6}, {0.06906340653195055, 
     5.402982353139566*^7}}], 
    LineBox[{{0.9085069166334584, 5.402982353139566*^7}, {0.9093365128833805, 
     2.0427209*^7}, {0.9100891294173559, -3.716885100598675*^7}}], 
    LineBox[{{0.30218966333575004`, -3.716885100598675*^7}, {
     0.30279807391056035`, 3.9655064*^7}, {0.3029458065236463, 
     5.402982353139566*^7}}], 
    LineBox[{{0.16467440494458996`, 5.402982353139566*^7}, {
     0.1653774969942921, 9.418724*^6}, {0.16616245464000548`, 1.9515269*^7}, {
     0.1663705783459979, 5.402982353139566*^7}}], 
    LineBox[{{0.03464541013463179, -3.716885100598675*^7}, {
     0.03480214930139765, 1.052435*^6}, {
     0.03507891206928404, -3.716885100598675*^7}}], 
    LineBox[{{0.3495140968368548, 5.402982353139566*^7}, {
     0.35022664377466206`, 310399.}, {0.3510878391656982, -1.618162*^6}, {
     0.3519490345567344, -1.4175095*^7}, {
     0.3522008026724569, -3.716885100598675*^7}}], 
    LineBox[{{0.4032444780239491, -3.716885100598675*^7}, {
     0.4038066023209693, -3.838226*^6}, {0.4046520918727271, -2.8770584*^7}, {
     0.4054975814244849, 5.961567*^6}, {0.40634307097624267`, 170233.}, {
     0.40701603340258685`, -3.716885100598675*^7}}], 
    LineBox[{{0.4539921351998902, 5.402982353139566*^7}, {
     0.45468582514780675`, 2.8150805*^7}, {0.4554744904392335, 3.814903*^6}, {
     0.4562631557306603, 2.018607*^6}, {
     0.4567178418023703, -3.716885100598675*^7}}], 
    LineBox[{{0.28316941499609627`, 5.402982353139566*^7}, {
     0.2837261285935381, 1.1645889*^7}, {0.2845207929817473, 1.309841*^6}, {
     0.28531545736995656`, 1.1293079*^7}, {
     0.28579849129597823`, -3.716885100598675*^7}}], 
    LineBox[{{0.4429778806482577, 5.402982353139566*^7}, {
     0.44364451106783204`, 1.126066*^6}, {0.44443317635925883`, 
     6.103768*^6}, {0.44498938031996155`, -3.716885100598675*^7}}], 
    LineBox[{{0.04735228924071776, 5.402982353139566*^7}, {
     0.04745745718133172, 5.1404798*^7}, {0.0482484139238276, 1.6556109*^7}, {
     0.04903937066632348, 1.1095799*^7}, {0.0494639298786213, 
     5.402982353139566*^7}}], 
    LineBox[{{0.10061248979406631`, 5.402982353139566*^7}, {
     0.10121306112535844`, 9.502489*^6}, {0.1020705488706812, 4.049023*^6}, {
     0.10292803661600397`, 3.280321*^6}, {0.10378552436132674`, 899981.}, {
     0.10415447925971803`, -3.716885100598675*^7}}], 
    LineBox[{{0.18187698599689925`, -3.716885100598675*^7}, {
     0.1826465651999865, 1.180942*^6}, {0.1834315228456999, 1.5515065*^7}, {
     0.1842164804914133, 3.363407*^6}, {
     0.18464935693163936`, -3.716885100598675*^7}}], 
    LineBox[{{0.08641101731975666, -3.716885100598675*^7}, {
     0.08663576945487142, 2.093177*^6}, {0.08749325720019419, 760070.}, {
     0.08796869795166745, 5.402982353139566*^7}}], 
    LineBox[{{0.07145078860615205, 5.402982353139566*^7}, {0.0720584777843844,
      2.054387*^6}, {0.07291596552970717, 8.483245*^6}, {0.07377345327502993, 
     1.1339621*^7}, {0.07425087708213345, -3.716885100598675*^7}}], 
    LineBox[{{0.0032532387184476285`, 5.402982353139566*^7}, {
     0.003954836344058344, 4.3644031*^7}, {0.004745793086554224, 
     5.3501279*^7}, {0.004748523559724298, 5.402982353139566*^7}}], 
    LineBox[{{0.10892431580330725`, 5.402982353139566*^7}, {
     0.10950381727693108`, 6.953648*^6}, {
     0.11030448076192284`, -7.384079*^6}, {0.11071050848482279`, 
     5.402982353139566*^7}}], 
    LineBox[{{0.3167994739324405, -3.716885100598675*^7}, {0.3175012189152884,
      2.079718*^6}, {0.31827187218531056`, -3.716885100598675*^7}}], 
    LineBox[{{0.18537031191150818`, -3.716885100598675*^7}, {
     0.18578639578284006`, 17434.}, {0.18657135342855344`, 254739.}, {
     0.1870064378566401, 5.402982353139566*^7}}], 
    LineBox[{{0.12242563729627007`, 5.402982353139566*^7}, {
     0.12311509652179098`, -2.4135586*^7}, {
     0.1237266368166952, -3.716885100598675*^7}}], 
    LineBox[{{0.6452962604144473, -3.716885100598675*^7}, {0.6457886121666061,
      557156.}, {0.6466378093640772, 1.0353012*^7}, {0.6473333962521761, 
     5.402982353139566*^7}}], 
    LineBox[{{0.8584838998838535, -3.716885100598675*^7}, {0.8592507147246684,
      241003.}, {0.8599215960992398, 5.402982353139566*^7}}], 
    LineBox[{{0.04217803269122498, 5.402982353139566*^7}, {
     0.042711716726356444`, 96367.}, {0.04340579629313709, 
     5.402982353139566*^7}}], 
    LineBox[{{0.25155814427534817`, 5.402982353139566*^7}, {
     0.2521091505897357, 2.2627711*^7}, {0.252960639238276, 684565.}, {
     0.2534679806424304, -3.716885100598675*^7}}], 
    LineBox[{{0.11592701934665142`, -3.716885100598675*^7}, {
     0.11670978864185691`, 6.090089*^6}, {0.11709791898941892`, 
     5.402982353139566*^7}}], 
    LineBox[{{0.17913608131094405`, -3.716885100598675*^7}, {
     0.17950673461713298`, 6.666229*^6}, {0.18029169226284636`, 60269.}, {
     0.18067036252948698`, 5.402982353139566*^7}}], 
    LineBox[{{0.012968696374522758`, 5.402982353139566*^7}, {
     0.013446317254008897`, 1.419199*^6}, {
     0.013635839860942706`, -3.716885100598675*^7}}], 
    LineBox[{{0.06490943642605544, 5.402982353139566*^7}, {
     0.06519857582180227, 8.973877*^6}, {0.06570731938140775, 
     5.402982353139566*^7}}], 
    LineBox[{{0.0069619454733489145`, 5.402982353139566*^7}, {
     0.007118663314041863, 5.090141*^6}, {0.007258987871545368, 
     5.402982353139566*^7}}], 
    LineBox[{{0.3060100615201914, -3.716885100598675*^7}, {0.3067713958516066,
      7.335873*^6}, {0.3075603478938932, -3.716885100598675*^7}}], 
    LineBox[{{0.08182281254652944, -3.716885100598675*^7}, {
     0.08234833072825759, 1.3756478*^7}, {0.0826056821189981, 
     5.402982353139566*^7}}], 
    LineBox[{{0.009936032436612022, -3.716885100598675*^7}, {
     0.010282490284025381`, 2.8118383*^7}, {0.010368595162098, 
     5.402982353139566*^7}}], 
    LineBox[{{0.060962981083283956`, 5.402982353139566*^7}, {
     0.061768624840511197`, 1.6275334*^7}, {0.062197967555494636`, 
     5.402982353139566*^7}}], 
    LineBox[{{0.8031965593268217, -3.716885100598675*^7}, {0.8040065757058104,
      130785.}, {0.804636204529022, -3.716885100598675*^7}}], 
    LineBox[{{0.3211611049750912, -3.716885100598675*^7}, {
     0.32180719587046913`, 608877.}, {0.3225973191228516, 
     5.402982353139566*^7}}], 
    LineBox[{{0.021221765533045396`, 5.402982353139566*^7}, {
     0.021355884678967693`, 9.993077*^6}, {0.02151901858897206, 
     5.402982353139566*^7}}], 
    LineBox[{{0.06995545523684989, 5.402982353139566*^7}, {
     0.07034350229373887, 4.105795*^6}, {0.07094400330452039, 
     5.402982353139566*^7}}], 
    LineBox[{{0.3046677341747184, 5.402982353139566*^7}, {
     0.30518206707518813`, 657093.}, {
     0.30593780472342125`, -3.716885100598675*^7}}], 
    LineBox[{{0.06301136036092694, 5.402982353139566*^7}, {
     0.06348360033115673, 7.879153*^6}, {0.06377735824749389, 
     5.402982353139566*^7}}], 
    LineBox[{{0.12154029219846953`, -3.716885100598675*^7}, {
     0.12222041213316756`, 5.402982353139566*^7}}], 
    LineBox[{{0.32270345155482805`, 5.402982353139566*^7}, {
     0.32336885945300325`, -3.716885100598675*^7}}], 
    LineBox[{{0.14080152618755812`, -3.716885100598675*^7}, {
     0.14133704697762467`, 5.402982353139566*^7}}], 
    LineBox[{{0.001729497256827188, 5.402982353139566*^7}, {
     0.0018622462330487367`, -3.716885100598675*^7}}], 
    LineBox[{{0.02707882034047256, 5.402982353139566*^7}, {
     0.02730092181471061, -3.716885100598675*^7}}], 
    LineBox[{{0.22240461332308759`, 5.402982353139566*^7}, {
     0.22293957226777047`, -3.716885100598675*^7}}], 
    LineBox[{{0.24963808824219988`, -3.716885100598675*^7}, {
     0.2502795258698773, 5.402982353139566*^7}}], 
    LineBox[{{0.00818744389549067, 5.402982353139566*^7}, {
     0.008299103227469523, -3.716885100598675*^7}}], 
    LineBox[{{0.017620169726310902`, 5.402982353139566*^7}, {
     0.017870728736026163`, -3.716885100598675*^7}}], 
    LineBox[{{0.2463761536019887, -3.716885100598675*^7}, {
     0.24697096972041674`, 5.402982353139566*^7}}], 
    LineBox[{{0.6670686118268135, -3.716885100598675*^7}, {0.6677513172686295,
      5.402982353139566*^7}}], 
    LineBox[{{0.3989708262158916, 5.402982353139566*^7}, {
     0.3995624802884791, -3.716885100598675*^7}}], 
    LineBox[{{0.16725030539427474`, 5.402982353139566*^7}, {
     0.16753907161666273`, -3.716885100598675*^7}}], 
    LineBox[{{0.14173151428770422`, 5.402982353139566*^7}, {
     0.14228877594294403`, -3.716885100598675*^7}}], 
    LineBox[{{0.002998819596876965, -3.716885100598675*^7}, {
     0.003161519722419486, 5.402982353139566*^7}}], 
    LineBox[{{0.02811673310987984, -3.716885100598675*^7}, {
     0.028368193929186547`, 5.402982353139566*^7}}], 
    LineBox[{{0.08081524838045286, 5.402982353139566*^7}, {
     0.08131467483713258, -3.716885100598675*^7}}], 
    LineBox[{{0.04046974773133546, -3.716885100598675*^7}, {
     0.0410609421134332, 5.402982353139566*^7}}], 
    LineBox[{{0.1875100789302457, 5.402982353139566*^7}, {
     0.18783437062362693`, -3.716885100598675*^7}}], 
    LineBox[{{0.1813799346355969, 5.402982353139566*^7}, {
     0.1818575937920707, -3.716885100598675*^7}}]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  Method->{},
  PlotRange->{{0, 1}, {-3.716885100598675*^7, 5.402982353139566*^7}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{{3.7269524064976716`*^9, 3.726952434763623*^9}, {
   3.7269524915948553`*^9, 3.726952546986161*^9}, 3.7269527220039263`*^9}]
}, Open  ]]
},
WindowSize->{710, 504},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
ShowSelection->True,
FrontEndVersion->"9.0 for Microsoft Windows (64-bit) (January 25, 2013)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 1135, 31, 112, "Input"],
Cell[1695, 53, 4013, 92, 352, "Input"],
Cell[CellGroupData[{
Cell[5733, 149, 1729, 35, 132, "Input"],
Cell[7465, 186, 1938, 38, 58, "Output"],
Cell[9406, 226, 1290, 17, 31, "Output"],
Cell[10699, 245, 1290, 17, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12026, 267, 1015, 23, 72, "Input"],
Cell[13044, 292, 607, 11, 21, "Message"],
Cell[13654, 305, 42265, 709, 217, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
