(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     55463,        987]
NotebookOptionsPosition[     54989,        966]
NotebookOutlinePosition[     55334,        981]
CellTagsIndexPosition[     55291,        978]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"GeneralizedFlintHills", "[", 
    RowBox[{"cscPower_", ",", "jPower_", ",", "nMax_"}], "]"}], ":=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{"N", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Csc", "[", "j", "]"}], "^", 
          RowBox[{"(", "cscPower", ")"}]}], "/", 
         RowBox[{"j", "^", 
          RowBox[{"(", "jPower", ")"}]}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", "1", ",", "n"}], "}"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"n", ",", "1", ",", "nMax"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.7826829375270524`*^9, 3.7826831000954733`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"GeneralizedFlintHills", "[", 
  RowBox[{"2", ",", "3", ",", "10000"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"\\", "Sigma_"}], 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"i", "=", "1"}], "}"}], "^", "n"}], " ", "\\", "frac"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\\", 
        RowBox[{"csc", "^", "2"}]}], " ", "i"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"i", "^", "3"}], "}"}], " ", "for", " ", "n"}], "\[LessEqual]", 
    "10000"}], " ", "*)"}]}]}], "Input",
 CellChangeTimes->{{3.782683104278068*^9, 3.7826831141202*^9}, {
  3.7826831578486376`*^9, 3.7826832583656*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwl1nc8lV8YAHAyS9mjIaOiRfmlkMhTdvbIKKtsEilRGVkNFZE9L9e4N1zc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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{None, None},
  AxesOrigin->{0, 30.278000000000002`},
  Method->{},
  PlotRange->{{1, 10000}, {30.278464506430296`, 30.31451083300305}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.782683117553563*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"GeneralizedFlintHills", "[", 
  RowBox[{"2", ",", "2", ",", "10000"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"\\", "Sigma_"}], 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"i", "=", "1"}], "}"}], "^", "n"}], " ", "\\", "frac"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\\", 
        RowBox[{"csc", "^", "2"}]}], " ", "i"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"i", "^", "2"}], "}"}], " ", "for", " ", "n"}], "\[LessEqual]", 
    "10000"}], " ", "*)"}]}]}], "Input",
 CellChangeTimes->{{3.7826831293837566`*^9, 3.782683137688094*^9}, {
  3.7826832634426928`*^9, 3.7826832668557463`*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwk13k8VW8TAHBrIQkhlWQnVBIlUVMJRVlSikjJXtFmKSmyhWTfl8u1r3eV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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{None, None},
  AxesOrigin->{0, 9410.},
  Method->{},
  PlotRange->{{1, 10000}, {9411.118574525346, 9488.766501262928}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.782683144017358*^9}]
}, Open  ]]
},
WindowSize->{707, 504},
WindowMargins->{{321, Automatic}, {Automatic, 63}},
FrontEndVersion->"9.0 for Microsoft Windows (64-bit) (January 25, 2013)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 724, 20, 52, "Input"],
Cell[CellGroupData[{
Cell[1306, 44, 699, 20, 52, "Input"],
Cell[2008, 66, 11048, 188, 236, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13093, 259, 707, 20, 52, "Input"],
Cell[13803, 281, 41170, 682, 237, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

